# Copyright (c) Microsoft Corporation.  All rights reserved.
from ._utils import record_new_telemetry_for_top_level
from ._detect_types_result import DetectTypesResult


@record_new_telemetry_for_top_level
def detect_types(data, options=None):
    """Generates code to dtect types for ??? :filename: with given
    options in :options:

    :param data: A data collection with string-valued data values. The type can be
        either a pandas dataframe, a dictionary mapping column names to lists of strings, or just
        an iterable of strings. In the first two cases, the data types are detected separately for
        each column and in the final case, a single data type is detected for the values in the list.
    :param options: Options to specify extra settings to learn code.
    :type options: :class `prose.codeaccelerator.DetectTypesOptions`

    :return: The result of learning.
    :rtype: :class:'prose.codeaccelerator.DetectTypesResult`.
    """
    return lambda logger: DetectTypesResult(logger, data, options)
