# Copyright (c) Microsoft Corporation.  All rights reserved.

from abc import abstractmethod
from ._result import ResultImpl


class BaseTelemetry(ResultImpl):
    """
    Base class for logging telemetry for DSLs that don't have equivalent C# side but everything happens on Python.
    E.g. `read_parquet`.
    """

    @property
    @abstractmethod
    def python_logger(self):
        pass

    @property
    def _telemetry_testing_data(self):
        """Get the list of collected telemetry events. None, if not in telemetry testing mode."""
        return (
            self._internal.python_logger.get_telemetry_testing_data()
            if self._internal.python_logger is not None
            else None
        )
