# Copyright (c) Microsoft Corporation.  All rights reserved.
# This file is auto-generated. Do not make manual changes.

from .protobuf_objects import ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseDispatchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseFetchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .background_process import BackgroundProcess, _ProcessState
from .cache_manager import CacheManager
from .protobuf_objects.background_process_terminate import process_terminator
from .null_value_converter_utils import NullValueConverterUtils
from . import cell_value


class CellValueFactoryApi(object):
    def create_int_value(self, value):
        """
        Creates afor int?.
        :param value: The value to set inside .
        :return: An instance ofwith value set to .
        """

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'CellValueFactory' object from request and set parameters
        cell_value_factory_request = request.iCellValueFactory
        NullValueConverterUtils.convert_to_pb_nullable_int32(cell_value_factory_request.i_In_CellValueFactory_CreateIntValue.value, value)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by CellValueFactory.CreateIntValue
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        cell_value_factory_response = response.iCellValueFactory.i_Out_CellValueFactory_CreateIntValue
        to_return = NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(cell_value_factory_response.result, self._cache_manager.get_object, cell_value.CellValue.prepopulated_object_builder)
        return to_return

    def create_double_value(self, value):
        """
        Creates afor double?.Double is needed because protobuf loses precision of float values while sending data to/from Python.
        :param value: The value to set inside .
        :return: An instance ofwith value set to .
        """

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'CellValueFactory' object from request and set parameters
        cell_value_factory_request = request.iCellValueFactory
        NullValueConverterUtils.convert_to_pb_nullable_double(cell_value_factory_request.i_In_CellValueFactory_CreateDoubleValue.value, value)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by CellValueFactory.CreateDoubleValue
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        cell_value_factory_response = response.iCellValueFactory.i_Out_CellValueFactory_CreateDoubleValue
        to_return = NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(cell_value_factory_response.result, self._cache_manager.get_object, cell_value.CellValue.prepopulated_object_builder)
        return to_return

    def create_string_value(self, value):
        """
        Creates afor string.
        :param value: The value to set inside .
        :return: An instance ofwith value set to .
        """

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'CellValueFactory' object from request and set parameters
        cell_value_factory_request = request.iCellValueFactory
        NullValueConverterUtils.convert_to_pb_nullable_string(cell_value_factory_request.i_In_CellValueFactory_CreateStringValue.value, value)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by CellValueFactory.CreateStringValue
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        cell_value_factory_response = response.iCellValueFactory.i_Out_CellValueFactory_CreateStringValue
        to_return = NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(cell_value_factory_response.result, self._cache_manager.get_object, cell_value.CellValue.prepopulated_object_builder)
        return to_return

    def create_date_time_value(self, value):
        """
        Creates afor DateTime?.
        :param value: The value to set inside .
        :return: An instance ofwith value set to .
        """

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'CellValueFactory' object from request and set parameters
        cell_value_factory_request = request.iCellValueFactory
        NullValueConverterUtils.convert_to_pb_nullable_datetime(cell_value_factory_request.i_In_CellValueFactory_CreateDateTimeValue.value, value)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by CellValueFactory.CreateDateTimeValue
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        cell_value_factory_response = response.iCellValueFactory.i_Out_CellValueFactory_CreateDateTimeValue
        to_return = NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(cell_value_factory_response.result, self._cache_manager.get_object, cell_value.CellValue.prepopulated_object_builder)
        return to_return

    def __init__(self, background_process, prepopulated_referenceId=None):
        assert background_process is not None
        self._background_process = background_process
        self._cache_manager = CacheManager(id(background_process))

        # if object was already created in C#, just initialize the referenceId.
        if prepopulated_referenceId is not None:
            self.referenceId = prepopulated_referenceId
            self._cache_manager.add_object(self.referenceId, self)
            return
        # else if object is constructed in Python, then create an equivalent in C#.

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher


        # Extract 'CellValueFactory' object from request and set parameters
        cell_value_factory_request = request.iCellValueFactory
        cell_value_factory_request.i_In_CellValueFactory___init__.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by CellValueFactory..ctor
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)
        # Ensure we have a valid referenceId
        if response.referenceId is 0:
            raise ValueError('Failed to create CellValueFactory object.')
        self.referenceId = response.referenceId
        # Cache the object
        self._cache_manager.add_object(self.referenceId, self)

    def __del__(self):

        # If we haven't initialized successfully, just return
        if not hasattr(self, 'referenceId'):
            return
        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId
        request.DeleteFromCache.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, just return
        if received_bytes is None:
            return

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by CellValueFactory.__del__
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    __slots__ = ['_background_process', '_cache_manager', 'referenceId', '__weakref__']


class CellValueFactory(CellValueFactoryApi):
    def __init__(self, prepopulated_referenceId=None):
        background_process = BackgroundProcess(r'Microsoft.ProgramSynthesis.Python.CodeAccelerator.Internals.dll', '04/18/2020 05:15:37', process_terminator)
        assert background_process._process_state == _ProcessState.RUNNING
        super().__init__(background_process, prepopulated_referenceId)

    def __del__(self):
        super().__del__()

    __slots__ = []

    @classmethod
    def prepopulated_object_builder(cls, prepopulated_referenceId):
        """
        Method to construct CellValueFactory object if equivalent C# object is already created
        """

        return CellValueFactory(prepopulated_referenceId)
