# Copyright (c) Microsoft Corporation.  All rights reserved.
# This file is auto-generated. Do not make manual changes.

from .protobuf_objects import ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseDispatchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseFetchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .background_process import BackgroundProcess, _ProcessState
from .cache_manager import CacheManager
from .protobuf_objects.background_process_terminate import process_terminator
from .null_value_converter_utils import NullValueConverterUtils
from . import column_info


class ColumnInfoApi(object):
    def __init__(self, background_process, columnName, columnNameIsInt, fixPandasNaNBug, useColumnForLearning, dataStream, trueLength, prepopulated_referenceId=None):
        """
        Constructor.
        :param columnName: See .
        :param columnNameIsInt: See .
        :param fixPandasNaNBug: See .
        :param useColumnForLearning: See .
        :param dataStream: The streamer to stream theassociated with this column.
        :param trueLength: Number of actual rows present in user input.
        :return:
        """
        assert background_process is not None
        self._background_process = background_process
        self._cache_manager = CacheManager(id(background_process))

        # if object was already created in C#, just initialize the referenceId.
        if prepopulated_referenceId is not None:
            self.referenceId = prepopulated_referenceId
            self._cache_manager.add_object(self.referenceId, self)
            return
        # else if object is constructed in Python, then create an equivalent in C#.

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher


        # Extract 'ColumnInfo' object from request and set parameters
        column_info_request = request.iColumnInfo
        NullValueConverterUtils.convert_to_pb_nullable_string(column_info_request.i_In_ColumnInfo___init__.columnName, columnName)
        column_info_request.i_In_ColumnInfo___init__.columnNameIsInt = columnNameIsInt
        column_info_request.i_In_ColumnInfo___init__.fixPandasNaNBug = fixPandasNaNBug
        column_info_request.i_In_ColumnInfo___init__.useColumnForLearning = useColumnForLearning
        NullValueConverterUtils.convert_to_pb_XplatPyNetFetcherObject(column_info_request.i_In_ColumnInfo___init__.dataStream, dataStream, self._cache_manager.add_fetcher_object)
        column_info_request.i_In_ColumnInfo___init__.trueLength = trueLength
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ColumnInfo..ctor
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)
        # Ensure we have a valid referenceId
        if response.referenceId is 0:
            raise ValueError('Failed to create ColumnInfo object.')
        self.referenceId = response.referenceId
        # Cache the object
        self._cache_manager.add_object(self.referenceId, self)

    def reset_data_stream(self):
        """

        :return:
        """

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ColumnInfo' object from request and set parameters
        column_info_request = request.iColumnInfo
        column_info_request.i_In_ColumnInfo_ResetDataStream.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ColumnInfo.ResetDataStream
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    def equals(self, other):
        """

        :return:
        """

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ColumnInfo' object from request and set parameters
        column_info_request = request.iColumnInfo
        NullValueConverterUtils.convert_to_pb_XplatPyNetCustomObject(column_info_request.i_In_ColumnInfo_Equals.other, other)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ColumnInfo.Equals
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        column_info_response = response.iColumnInfo.i_Out_ColumnInfo_Equals
        to_return = column_info_response.result
        return to_return

    def get_hash_code(self):
        """

        :return:
        """

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ColumnInfo' object from request and set parameters
        column_info_request = request.iColumnInfo
        column_info_request.i_In_ColumnInfo_GetHashCode.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ColumnInfo.GetHashCode
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        column_info_response = response.iColumnInfo.i_Out_ColumnInfo_GetHashCode
        to_return = column_info_response.result
        return to_return

    def get_column_name(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ColumnInfo' object from request and set parameters
        column_info_request = request.iColumnInfo
        column_info_request.i_In_ColumnInfo_get_ColumnName.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ColumnInfo.get_ColumnName
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        column_info_response = response.iColumnInfo.i_Out_ColumnInfo_get_ColumnName
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(column_info_response.result)
        return to_return

    def get_column_name_is_int(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ColumnInfo' object from request and set parameters
        column_info_request = request.iColumnInfo
        column_info_request.i_In_ColumnInfo_get_ColumnNameIsInt.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ColumnInfo.get_ColumnNameIsInt
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        column_info_response = response.iColumnInfo.i_Out_ColumnInfo_get_ColumnNameIsInt
        to_return = column_info_response.result
        return to_return

    def get_fix_pandas_na_nbug(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ColumnInfo' object from request and set parameters
        column_info_request = request.iColumnInfo
        column_info_request.i_In_ColumnInfo_get_FixPandasNaNBug.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ColumnInfo.get_FixPandasNaNBug
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        column_info_response = response.iColumnInfo.i_Out_ColumnInfo_get_FixPandasNaNBug
        to_return = column_info_response.result
        return to_return

    def get_use_column_for_learning(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ColumnInfo' object from request and set parameters
        column_info_request = request.iColumnInfo
        column_info_request.i_In_ColumnInfo_get_UseColumnForLearning.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ColumnInfo.get_UseColumnForLearning
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        column_info_response = response.iColumnInfo.i_Out_ColumnInfo_get_UseColumnForLearning
        to_return = column_info_response.result
        return to_return

    def get_data(self):
        def _convert_from_pb_0(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            return [NullValueConverterUtils.convert_from_pb_nullable_string(python_object) for python_object in protobuf_object.Value]


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ColumnInfo' object from request and set parameters
        column_info_request = request.iColumnInfo
        column_info_request.i_In_ColumnInfo_get_Data.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ColumnInfo.get_Data
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        column_info_response = response.iColumnInfo.i_Out_ColumnInfo_get_Data
        to_return = _convert_from_pb_0(column_info_response.result)
        return to_return

    def get_true_length(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ColumnInfo' object from request and set parameters
        column_info_request = request.iColumnInfo
        column_info_request.i_In_ColumnInfo_get_TrueLength.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ColumnInfo.get_TrueLength
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        column_info_response = response.iColumnInfo.i_Out_ColumnInfo_get_TrueLength
        to_return = NullValueConverterUtils.convert_from_pb_nullable_int64(column_info_response.result)
        return to_return

    def get_column_name_literal(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ColumnInfo' object from request and set parameters
        column_info_request = request.iColumnInfo
        column_info_request.i_In_ColumnInfo_get_ColumnNameLiteral.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ColumnInfo.get_ColumnNameLiteral
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        column_info_response = response.iColumnInfo.i_Out_ColumnInfo_get_ColumnNameLiteral
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(column_info_response.result)
        return to_return

    def get_column_name_for_identifier(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ColumnInfo' object from request and set parameters
        column_info_request = request.iColumnInfo
        column_info_request.i_In_ColumnInfo_get_ColumnNameForIdentifier.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ColumnInfo.get_ColumnNameForIdentifier
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        column_info_response = response.iColumnInfo.i_Out_ColumnInfo_get_ColumnNameForIdentifier
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(column_info_response.result)
        return to_return

    column_name = property(get_column_name, None, None, 'accessor for ColumnName')
    column_name_is_int = property(get_column_name_is_int, None, None, 'accessor for ColumnNameIsInt')
    fix_pandas_na_nbug = property(get_fix_pandas_na_nbug, None, None, 'accessor for FixPandasNaNBug')
    use_column_for_learning = property(get_use_column_for_learning, None, None, 'accessor for UseColumnForLearning')
    data = property(get_data, None, None, 'accessor for Data')
    true_length = property(get_true_length, None, None, 'accessor for TrueLength')
    column_name_literal = property(get_column_name_literal, None, None, 'accessor for ColumnNameLiteral')
    column_name_for_identifier = property(get_column_name_for_identifier, None, None, 'accessor for ColumnNameForIdentifier')
    def __del__(self):

        # If we haven't initialized successfully, just return
        if not hasattr(self, 'referenceId'):
            return
        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId
        request.DeleteFromCache.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, just return
        if received_bytes is None:
            return

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ColumnInfo.__del__
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    __slots__ = ['_background_process', '_cache_manager', 'referenceId', '__weakref__']


class ColumnInfo(ColumnInfoApi):
    def __init__(self, columnName, columnNameIsInt, fixPandasNaNBug, useColumnForLearning, dataStream, trueLength, prepopulated_referenceId=None):
        """
        Constructor.
        :param columnName: See .
        :param columnNameIsInt: See .
        :param fixPandasNaNBug: See .
        :param useColumnForLearning: See .
        :param dataStream: The streamer to stream theassociated with this column.
        :param trueLength: Number of actual rows present in user input.
        :return:
        """
        background_process = BackgroundProcess(r'Microsoft.ProgramSynthesis.Python.CodeAccelerator.Internals.dll', '04/18/2020 05:15:37', process_terminator)
        assert background_process._process_state == _ProcessState.RUNNING
        super().__init__(background_process, columnName, columnNameIsInt, fixPandasNaNBug, useColumnForLearning, dataStream, trueLength, prepopulated_referenceId)

    def __del__(self):
        super().__del__()

    __slots__ = []

    @classmethod
    def prepopulated_object_builder(cls, prepopulated_referenceId):
        """
        Method to construct ColumnInfo object if equivalent C# object is already created
        """

        return ColumnInfo(None, None, None, None, None, None, prepopulated_referenceId)
