# Copyright (c) Microsoft Corporation.  All rights reserved.
# This file is auto-generated. Do not make manual changes.

from .protobuf_objects import ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseDispatchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseFetchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .background_process import BackgroundProcess, _ProcessState
from .cache_manager import CacheManager
from .protobuf_objects.background_process_terminate import process_terminator
from .null_value_converter_utils import NullValueConverterUtils
from . import cell_value
from . import python_logger


class DeriveValueLearnResultApi(object):
    def get_code_string(self):
        """
        Creates the string representation of the learned program.
        :return:
        """

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DeriveValueLearnResult' object from request and set parameters
        derive_value_learn_result_request = request.iDeriveValueLearnResult
        derive_value_learn_result_request.i_In_DeriveValueLearnResult_GetCodeString.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DeriveValueLearnResult.GetCodeString
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        derive_value_learn_result_response = response.iDeriveValueLearnResult.i_Out_DeriveValueLearnResult_GetCodeString
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(derive_value_learn_result_response.result)
        return to_return

    def get_suggestions(self):
        """
        Get a list of input suggestions that could help refine another round of learning.
        :return:
        """
        def _convert_from_pb_4(protobuf_object, cache_object_getter):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            return [NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(python_object, cache_object_getter, cell_value.CellValue.prepopulated_object_builder) for python_object in protobuf_object.Value]


        def _convert_from_pb_5(protobuf_object, cache_object_getter):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            python_object = []
            for inner_pb_object in protobuf_object.Value:
                python_object.append(_convert_from_pb_4(inner_pb_object, cache_object_getter))
            return python_object


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DeriveValueLearnResult' object from request and set parameters
        derive_value_learn_result_request = request.iDeriveValueLearnResult
        derive_value_learn_result_request.i_In_DeriveValueLearnResult_GetSuggestions.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DeriveValueLearnResult.GetSuggestions
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        derive_value_learn_result_response = response.iDeriveValueLearnResult.i_Out_DeriveValueLearnResult_GetSuggestions
        to_return = _convert_from_pb_5(derive_value_learn_result_response.result, self._cache_manager.get_object)
        return to_return

    def get_telemetry_testing_data(self):
        """
        Gets the testing telemetry events.
        :return: The testing telemetry events as tuples of event name and session type.
        """
        def _convert_from_pb_6(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None

            return NullValueConverterUtils.convert_from_pb_nullable_string(protobuf_object.item1), NullValueConverterUtils.convert_from_pb_nullable_string(protobuf_object.item2)

        def _convert_from_pb_7(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            python_object = []
            for inner_pb_object in protobuf_object.Value:
                python_object.append(_convert_from_pb_6(inner_pb_object))
            return python_object


        def _convert_from_pb_8(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            python_object = []
            for inner_pb_object in protobuf_object.Value:
                python_object.append(_convert_from_pb_7(inner_pb_object))
            return python_object


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DeriveValueLearnResult' object from request and set parameters
        derive_value_learn_result_request = request.iDeriveValueLearnResult
        derive_value_learn_result_request.i_In_DeriveValueLearnResult_GetTelemetryTestingData.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DeriveValueLearnResult.GetTelemetryTestingData
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        derive_value_learn_result_response = response.iDeriveValueLearnResult.i_Out_DeriveValueLearnResult_GetTelemetryTestingData
        to_return = _convert_from_pb_8(derive_value_learn_result_response.result)
        return to_return

    def get_python_logger(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DeriveValueLearnResult' object from request and set parameters
        derive_value_learn_result_request = request.iDeriveValueLearnResult
        derive_value_learn_result_request.i_In_DeriveValueLearnResult_get_PythonLogger.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DeriveValueLearnResult.get_PythonLogger
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        derive_value_learn_result_response = response.iDeriveValueLearnResult.i_Out_DeriveValueLearnResult_get_PythonLogger
        to_return = NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(derive_value_learn_result_response.result, self._cache_manager.get_object, python_logger.PythonLogger.prepopulated_object_builder)
        return to_return

    def __init__(self, background_process, prepopulated_referenceId):
        assert background_process is not None
        assert prepopulated_referenceId is not None
        self._background_process = background_process
        self._cache_manager = CacheManager(id(background_process))

        # This object is already created in C#, just initialize the referenceId.
        self.referenceId = prepopulated_referenceId
        self._cache_manager.add_object(self.referenceId, self)
    def _get_error(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DeriveValueLearnResult' object from request and set parameters
        derive_value_learn_result_request = request.iDeriveValueLearnResult
        derive_value_learn_result_request.i_In_DeriveValueLearnResult__get_Error.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DeriveValueLearnResult.Error
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        derive_value_learn_result_response = response.iDeriveValueLearnResult.i_Out_DeriveValueLearnResult__get_Error
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(derive_value_learn_result_response.result)
        return to_return

    python_logger = property(get_python_logger, None, None, 'accessor for PythonLogger')
    error = property(_get_error, None, None, 'accessor for Error')
    def __del__(self):

        # If we haven't initialized successfully, just return
        if not hasattr(self, 'referenceId'):
            return
        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId
        request.DeleteFromCache.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, just return
        if received_bytes is None:
            return

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DeriveValueLearnResult.__del__
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    __slots__ = ['_background_process', '_cache_manager', 'referenceId', '__weakref__']


class DeriveValueLearnResult(DeriveValueLearnResultApi):
    def __init__(self, prepopulated_referenceId):
        background_process = BackgroundProcess(r'Microsoft.ProgramSynthesis.Python.CodeAccelerator.Internals.dll', '04/18/2020 05:15:37', process_terminator)
        assert background_process._process_state == _ProcessState.RUNNING
        super().__init__(background_process, prepopulated_referenceId)

    def __del__(self):
        super().__del__()

    __slots__ = []

    @classmethod
    def prepopulated_object_builder(cls, prepopulated_referenceId):
        """
        Method to construct DeriveValueLearnResult object if equivalent C# object is already created
        """

        return DeriveValueLearnResult(prepopulated_referenceId)
