# Copyright (c) Microsoft Corporation.  All rights reserved.
# This file is auto-generated. Do not make manual changes.

from .protobuf_objects import ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseDispatchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseFetchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .background_process import BackgroundProcess, _ProcessState
from .cache_manager import CacheManager
from .protobuf_objects.background_process_terminate import process_terminator
from .null_value_converter_utils import NullValueConverterUtils
from . import python_logger


class DetectFileTypeApi(object):
    def __init__(self, background_process, logger, inputName, inputStream, prepopulated_referenceId=None):
        assert background_process is not None
        self._background_process = background_process
        self._cache_manager = CacheManager(id(background_process))

        # if object was already created in C#, just initialize the referenceId.
        if prepopulated_referenceId is not None:
            self.referenceId = prepopulated_referenceId
            self._cache_manager.add_object(self.referenceId, self)
            return
        # else if object is constructed in Python, then create an equivalent in C#.

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher


        # Extract 'DetectFileType' object from request and set parameters
        detect_file_type_request = request.iDetectFileType
        NullValueConverterUtils.convert_to_pb_XplatPyNetCustomObject(detect_file_type_request.i_In_DetectFileType___init__.logger, logger)
        NullValueConverterUtils.convert_to_pb_nullable_string(detect_file_type_request.i_In_DetectFileType___init__.inputName, inputName)
        NullValueConverterUtils.convert_to_pb_XplatPyNetFetcherObject(detect_file_type_request.i_In_DetectFileType___init__.inputStream, inputStream, self._cache_manager.add_fetcher_object)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectFileType..ctor
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)
        # Ensure we have a valid referenceId
        if response.referenceId is 0:
            raise ValueError('Failed to create DetectFileType object.')
        self.referenceId = response.referenceId
        # Cache the object
        self._cache_manager.add_object(self.referenceId, self)

    def detect(self):
        """
        Do the file-type detection.
        :return:
        """

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectFileType' object from request and set parameters
        detect_file_type_request = request.iDetectFileType
        detect_file_type_request.i_In_DetectFileType_Detect.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectFileType.Detect
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        detect_file_type_response = response.iDetectFileType.i_Out_DetectFileType_Detect
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(detect_file_type_response.result)
        return to_return

    def get_telemetry_testing_data(self):
        """
        Gets the testing telemetry events.
        :return: The testing telemetry events as tuples of event name and session type.
        """
        def _convert_from_pb_9(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None

            return NullValueConverterUtils.convert_from_pb_nullable_string(protobuf_object.item1), NullValueConverterUtils.convert_from_pb_nullable_string(protobuf_object.item2)

        def _convert_from_pb_10(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            python_object = []
            for inner_pb_object in protobuf_object.Value:
                python_object.append(_convert_from_pb_9(inner_pb_object))
            return python_object


        def _convert_from_pb_11(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            python_object = []
            for inner_pb_object in protobuf_object.Value:
                python_object.append(_convert_from_pb_10(inner_pb_object))
            return python_object


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectFileType' object from request and set parameters
        detect_file_type_request = request.iDetectFileType
        detect_file_type_request.i_In_DetectFileType_GetTelemetryTestingData.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectFileType.GetTelemetryTestingData
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        detect_file_type_response = response.iDetectFileType.i_Out_DetectFileType_GetTelemetryTestingData
        to_return = _convert_from_pb_11(detect_file_type_response.result)
        return to_return

    def get_python_logger(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectFileType' object from request and set parameters
        detect_file_type_request = request.iDetectFileType
        detect_file_type_request.i_In_DetectFileType_get_PythonLogger.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectFileType.get_PythonLogger
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        detect_file_type_response = response.iDetectFileType.i_Out_DetectFileType_get_PythonLogger
        to_return = NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(detect_file_type_response.result, self._cache_manager.get_object, python_logger.PythonLogger.prepopulated_object_builder)
        return to_return

    python_logger = property(get_python_logger, None, None, 'accessor for PythonLogger')
    def __del__(self):

        # If we haven't initialized successfully, just return
        if not hasattr(self, 'referenceId'):
            return
        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId
        request.DeleteFromCache.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, just return
        if received_bytes is None:
            return

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectFileType.__del__
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    __slots__ = ['_background_process', '_cache_manager', 'referenceId', '__weakref__']


class DetectFileType(DetectFileTypeApi):
    def __init__(self, logger, inputName, inputStream, prepopulated_referenceId=None):
        background_process = BackgroundProcess(r'Microsoft.ProgramSynthesis.Python.CodeAccelerator.Internals.dll', '04/18/2020 05:15:37', process_terminator)
        assert background_process._process_state == _ProcessState.RUNNING
        super().__init__(background_process, logger, inputName, inputStream, prepopulated_referenceId)

    def __del__(self):
        super().__del__()

    __slots__ = []

    @classmethod
    def prepopulated_object_builder(cls, prepopulated_referenceId):
        """
        Method to construct DetectFileType object if equivalent C# object is already created
        """

        return DetectFileType(None, None, None, prepopulated_referenceId)
