# Copyright (c) Microsoft Corporation.  All rights reserved.
# This file is auto-generated. Do not make manual changes.

from .protobuf_objects import ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseDispatchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseFetchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .background_process import BackgroundProcess, _ProcessState
from .cache_manager import CacheManager
from .protobuf_objects.background_process_terminate import process_terminator
from .null_value_converter_utils import NullValueConverterUtils


class DetectTypesOptionsApi(object):
    def __init__(self, background_process, prepopulated_referenceId=None):
        assert background_process is not None
        self._background_process = background_process
        self._cache_manager = CacheManager(id(background_process))

        # if object was already created in C#, just initialize the referenceId.
        if prepopulated_referenceId is not None:
            self.referenceId = prepopulated_referenceId
            self._cache_manager.add_object(self.referenceId, self)
            return
        # else if object is constructed in Python, then create an equivalent in C#.

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher


        # Extract 'DetectTypesOptions' object from request and set parameters
        detect_types_options_request = request.iDetectTypesOptions
        detect_types_options_request.i_In_DetectTypesOptions___init__.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions..ctor
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)
        # Ensure we have a valid referenceId
        if response.referenceId is 0:
            raise ValueError('Failed to create DetectTypesOptions object.')
        self.referenceId = response.referenceId
        # Cache the object
        self._cache_manager.add_object(self.referenceId, self)

    def get_mode(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectTypesOptions' object from request and set parameters
        detect_types_options_request = request.iDetectTypesOptions
        detect_types_options_request.i_In_DetectTypesOptions_get_Mode.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions.get_Mode
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        detect_types_options_response = response.iDetectTypesOptions.i_Out_DetectTypesOptions_get_Mode
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(detect_types_options_response.result)
        return to_return

    def set_mode(self, value):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectTypesOptions' object from request and set parameters
        detect_types_options_request = request.iDetectTypesOptions
        NullValueConverterUtils.convert_to_pb_nullable_string(detect_types_options_request.i_In_DetectTypesOptions_set_Mode.value, value)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions.set_Mode
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    def get_true_length(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectTypesOptions' object from request and set parameters
        detect_types_options_request = request.iDetectTypesOptions
        detect_types_options_request.i_In_DetectTypesOptions_get_TrueLength.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions.get_TrueLength
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        detect_types_options_response = response.iDetectTypesOptions.i_Out_DetectTypesOptions_get_TrueLength
        to_return = NullValueConverterUtils.convert_from_pb_nullable_int32(detect_types_options_response.result)
        return to_return

    def set_true_length(self, value):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectTypesOptions' object from request and set parameters
        detect_types_options_request = request.iDetectTypesOptions
        NullValueConverterUtils.convert_to_pb_nullable_int32(detect_types_options_request.i_In_DetectTypesOptions_set_TrueLength.value, value)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions.set_TrueLength
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    def get_rows_to_analyze(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectTypesOptions' object from request and set parameters
        detect_types_options_request = request.iDetectTypesOptions
        detect_types_options_request.i_In_DetectTypesOptions_get_RowsToAnalyze.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions.get_RowsToAnalyze
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        detect_types_options_response = response.iDetectTypesOptions.i_Out_DetectTypesOptions_get_RowsToAnalyze
        to_return = NullValueConverterUtils.convert_from_pb_nullable_int32(detect_types_options_response.result)
        return to_return

    def set_rows_to_analyze(self, value):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectTypesOptions' object from request and set parameters
        detect_types_options_request = request.iDetectTypesOptions
        NullValueConverterUtils.convert_to_pb_nullable_int32(detect_types_options_request.i_In_DetectTypesOptions_set_RowsToAnalyze.value, value)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions.set_RowsToAnalyze
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    def get_types_to_detect(self):
        def _convert_from_pb_12(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            return [NullValueConverterUtils.convert_from_pb_nullable_string(python_object) for python_object in protobuf_object.Value]


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectTypesOptions' object from request and set parameters
        detect_types_options_request = request.iDetectTypesOptions
        detect_types_options_request.i_In_DetectTypesOptions_get_TypesToDetect.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions.get_TypesToDetect
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        detect_types_options_response = response.iDetectTypesOptions.i_Out_DetectTypesOptions_get_TypesToDetect
        to_return = _convert_from_pb_12(detect_types_options_response.result)
        return to_return

    def set_types_to_detect(self, value):
        def _convert_to_pb_6(protobuf_object, python_object) -> None:
            """
            Converts the python_object and sets converted object in appropriate fields of protobuf_object. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if python_object is None:
                protobuf_object.IsNullValue = True
                return

            if len(python_object) == 0:
                protobuf_object.Value.extend(python_object)
                return

            for inner_py_object in python_object:
                inner_pb_object = protobuf_object.Value.add()
                NullValueConverterUtils.convert_to_pb_nullable_string(inner_pb_object, inner_py_object)


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectTypesOptions' object from request and set parameters
        detect_types_options_request = request.iDetectTypesOptions
        _convert_to_pb_6(detect_types_options_request.i_In_DetectTypesOptions_set_TypesToDetect.value, value)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions.set_TypesToDetect
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    def get_detected_types(self):
        def _convert_from_pb_13(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            return [NullValueConverterUtils.convert_from_pb_nullable_string(python_object) for python_object in protobuf_object.Value]


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectTypesOptions' object from request and set parameters
        detect_types_options_request = request.iDetectTypesOptions
        detect_types_options_request.i_In_DetectTypesOptions_get_DetectedTypes.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions.get_DetectedTypes
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        detect_types_options_response = response.iDetectTypesOptions.i_Out_DetectTypesOptions_get_DetectedTypes
        to_return = _convert_from_pb_13(detect_types_options_response.result)
        return to_return

    def get_should_generate_code_with_input_from_read_apis(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectTypesOptions' object from request and set parameters
        detect_types_options_request = request.iDetectTypesOptions
        detect_types_options_request.i_In_DetectTypesOptions_get_ShouldGenerateCodeWithInputFromReadApis.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions.get_ShouldGenerateCodeWithInputFromReadApis
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        detect_types_options_response = response.iDetectTypesOptions.i_Out_DetectTypesOptions_get_ShouldGenerateCodeWithInputFromReadApis
        to_return = detect_types_options_response.result
        return to_return

    def set_should_generate_code_with_input_from_read_apis(self, value):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectTypesOptions' object from request and set parameters
        detect_types_options_request = request.iDetectTypesOptions
        detect_types_options_request.i_In_DetectTypesOptions_set_ShouldGenerateCodeWithInputFromReadApis.value = value
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions.set_ShouldGenerateCodeWithInputFromReadApis
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    def get_target(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectTypesOptions' object from request and set parameters
        detect_types_options_request = request.iDetectTypesOptions
        detect_types_options_request.i_In_DetectTypesOptions_get_Target.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions.get_Target
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        detect_types_options_response = response.iDetectTypesOptions.i_Out_DetectTypesOptions_get_Target
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(detect_types_options_response.result)
        return to_return

    def set_target(self, value):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectTypesOptions' object from request and set parameters
        detect_types_options_request = request.iDetectTypesOptions
        NullValueConverterUtils.convert_to_pb_nullable_string(detect_types_options_request.i_In_DetectTypesOptions_set_Target.value, value)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions.set_Target
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    def get_detect_data_types(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectTypesOptions' object from request and set parameters
        detect_types_options_request = request.iDetectTypesOptions
        detect_types_options_request.i_In_DetectTypesOptions_get_DetectDataTypes.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions.get_DetectDataTypes
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        detect_types_options_response = response.iDetectTypesOptions.i_Out_DetectTypesOptions_get_DetectDataTypes
        to_return = detect_types_options_response.result
        return to_return

    def set_detect_data_types(self, value):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectTypesOptions' object from request and set parameters
        detect_types_options_request = request.iDetectTypesOptions
        detect_types_options_request.i_In_DetectTypesOptions_set_DetectDataTypes.value = value
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions.set_DetectDataTypes
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    def get_allowed_targets(self):
        def _convert_from_pb_14(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            return [NullValueConverterUtils.convert_from_pb_nullable_string(python_object) for python_object in protobuf_object.Value]


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DetectTypesOptions' object from request and set parameters
        detect_types_options_request = request.iDetectTypesOptions
        detect_types_options_request.i_In_DetectTypesOptions_get_AllowedTargets.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions.get_AllowedTargets
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        detect_types_options_response = response.iDetectTypesOptions.i_Out_DetectTypesOptions_get_AllowedTargets
        to_return = _convert_from_pb_14(detect_types_options_response.result)
        return to_return

    mode = property(get_mode, set_mode, None, 'accessor for Mode')
    true_length = property(get_true_length, set_true_length, None, 'accessor for TrueLength')
    rows_to_analyze = property(get_rows_to_analyze, set_rows_to_analyze, None, 'accessor for RowsToAnalyze')
    types_to_detect = property(get_types_to_detect, set_types_to_detect, None, 'accessor for TypesToDetect')
    detected_types = property(get_detected_types, None, None, 'accessor for DetectedTypes')
    should_generate_code_with_input_from_read_apis = property(get_should_generate_code_with_input_from_read_apis, set_should_generate_code_with_input_from_read_apis, None, 'accessor for ShouldGenerateCodeWithInputFromReadApis')
    target = property(get_target, set_target, None, 'accessor for Target')
    detect_data_types = property(get_detect_data_types, set_detect_data_types, None, 'accessor for DetectDataTypes')
    allowed_targets = property(get_allowed_targets, None, None, 'accessor for AllowedTargets')
    def __del__(self):

        # If we haven't initialized successfully, just return
        if not hasattr(self, 'referenceId'):
            return
        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId
        request.DeleteFromCache.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, just return
        if received_bytes is None:
            return

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DetectTypesOptions.__del__
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    __slots__ = ['_background_process', '_cache_manager', 'referenceId', '__weakref__']


class DetectTypesOptions(DetectTypesOptionsApi):
    def __init__(self, prepopulated_referenceId=None):
        background_process = BackgroundProcess(r'Microsoft.ProgramSynthesis.Python.CodeAccelerator.Internals.dll', '04/18/2020 05:15:37', process_terminator)
        assert background_process._process_state == _ProcessState.RUNNING
        super().__init__(background_process, prepopulated_referenceId)

    def __del__(self):
        super().__del__()

    __slots__ = []

    @classmethod
    def prepopulated_object_builder(cls, prepopulated_referenceId):
        """
        Method to construct DetectTypesOptions object if equivalent C# object is already created
        """

        return DetectTypesOptions(prepopulated_referenceId)
