# Copyright (c) Microsoft Corporation.  All rights reserved.
# This file is auto-generated. Do not make manual changes.

from .protobuf_objects import ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseDispatchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseFetchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .background_process import BackgroundProcess, _ProcessState
from .cache_manager import CacheManager
from .protobuf_objects.background_process_terminate import process_terminator
from .null_value_converter_utils import NullValueConverterUtils
from . import column_info
from . import domain_type_profile_result
from . import python_logger


class DomainTypeProfileBuilderApi(object):
    def __init__(self, background_process, logger, columnInfos, prepopulated_referenceId=None):
        """
        Constructs afor a given dataset.
        :param logger: Logger for telemetry events.
        :return:
        """
        def _convert_to_pb_8(protobuf_object, python_object) -> None:
            """
            Converts the python_object and sets converted object in appropriate fields of protobuf_object. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if python_object is None:
                protobuf_object.IsNullValue = True
                return

            if len(python_object) == 0:
                protobuf_object.Value.extend(python_object)
                return

            for inner_py_object in python_object:
                inner_pb_object = protobuf_object.Value.add()
                NullValueConverterUtils.convert_to_pb_XplatPyNetCustomObject(inner_pb_object, inner_py_object)

        assert background_process is not None
        self._background_process = background_process
        self._cache_manager = CacheManager(id(background_process))

        # if object was already created in C#, just initialize the referenceId.
        if prepopulated_referenceId is not None:
            self.referenceId = prepopulated_referenceId
            self._cache_manager.add_object(self.referenceId, self)
            return
        # else if object is constructed in Python, then create an equivalent in C#.

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher


        # Extract 'DomainTypeProfileBuilder' object from request and set parameters
        domain_type_profile_builder_request = request.iDomainTypeProfileBuilder
        NullValueConverterUtils.convert_to_pb_XplatPyNetCustomObject(domain_type_profile_builder_request.i_In_DomainTypeProfileBuilder___init__.logger, logger)
        _convert_to_pb_8(domain_type_profile_builder_request.i_In_DomainTypeProfileBuilder___init__.columnInfos, columnInfos)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DomainTypeProfileBuilder..ctor
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)
        # Ensure we have a valid referenceId
        if response.referenceId is 0:
            raise ValueError('Failed to create DomainTypeProfileBuilder object.')
        self.referenceId = response.referenceId
        # Cache the object
        self._cache_manager.add_object(self.referenceId, self)

    def learn(self, newLogger, namesOfTypesToDetect):
        """
        Learns the datatypes for the dataset.
        :param newLogger: Logger for telemetry events.
        :param namesOfTypesToDetect: A list of strings representing the names of types to detect.
        :return: Athat encapsulates the results of datatype detection.
        """
        def _convert_to_pb_9(protobuf_object, python_object) -> None:
            """
            Converts the python_object and sets converted object in appropriate fields of protobuf_object. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if python_object is None:
                protobuf_object.IsNullValue = True
                return

            if len(python_object) == 0:
                protobuf_object.Value.extend(python_object)
                return

            for inner_py_object in python_object:
                inner_pb_object = protobuf_object.Value.add()
                NullValueConverterUtils.convert_to_pb_nullable_string(inner_pb_object, inner_py_object)


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DomainTypeProfileBuilder' object from request and set parameters
        domain_type_profile_builder_request = request.iDomainTypeProfileBuilder
        NullValueConverterUtils.convert_to_pb_XplatPyNetCustomObject(domain_type_profile_builder_request.i_In_DomainTypeProfileBuilder_Learn.newLogger, newLogger)
        _convert_to_pb_9(domain_type_profile_builder_request.i_In_DomainTypeProfileBuilder_Learn.namesOfTypesToDetect, namesOfTypesToDetect)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DomainTypeProfileBuilder.Learn
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        domain_type_profile_builder_response = response.iDomainTypeProfileBuilder.i_Out_DomainTypeProfileBuilder_Learn
        to_return = NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(domain_type_profile_builder_response.result, self._cache_manager.get_object, domain_type_profile_result.DomainTypeProfileResult.prepopulated_object_builder)
        return to_return

    def get_telemetry_testing_data(self):
        """
        Gets the testing telemetry events.
        :return: The testing telemetry events as tuples of event name and session type.
        """
        def _convert_from_pb_18(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None

            return NullValueConverterUtils.convert_from_pb_nullable_string(protobuf_object.item1), NullValueConverterUtils.convert_from_pb_nullable_string(protobuf_object.item2)

        def _convert_from_pb_19(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            python_object = []
            for inner_pb_object in protobuf_object.Value:
                python_object.append(_convert_from_pb_18(inner_pb_object))
            return python_object


        def _convert_from_pb_20(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            python_object = []
            for inner_pb_object in protobuf_object.Value:
                python_object.append(_convert_from_pb_19(inner_pb_object))
            return python_object


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DomainTypeProfileBuilder' object from request and set parameters
        domain_type_profile_builder_request = request.iDomainTypeProfileBuilder
        domain_type_profile_builder_request.i_In_DomainTypeProfileBuilder_GetTelemetryTestingData.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DomainTypeProfileBuilder.GetTelemetryTestingData
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        domain_type_profile_builder_response = response.iDomainTypeProfileBuilder.i_Out_DomainTypeProfileBuilder_GetTelemetryTestingData
        to_return = _convert_from_pb_20(domain_type_profile_builder_response.result)
        return to_return

    def get_python_logger(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DomainTypeProfileBuilder' object from request and set parameters
        domain_type_profile_builder_request = request.iDomainTypeProfileBuilder
        domain_type_profile_builder_request.i_In_DomainTypeProfileBuilder_get_PythonLogger.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DomainTypeProfileBuilder.get_PythonLogger
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        domain_type_profile_builder_response = response.iDomainTypeProfileBuilder.i_Out_DomainTypeProfileBuilder_get_PythonLogger
        to_return = NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(domain_type_profile_builder_response.result, self._cache_manager.get_object, python_logger.PythonLogger.prepopulated_object_builder)
        return to_return

    python_logger = property(get_python_logger, None, None, 'accessor for PythonLogger')
    def __del__(self):

        # If we haven't initialized successfully, just return
        if not hasattr(self, 'referenceId'):
            return
        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId
        request.DeleteFromCache.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, just return
        if received_bytes is None:
            return

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DomainTypeProfileBuilder.__del__
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    __slots__ = ['_background_process', '_cache_manager', 'referenceId', '__weakref__']


class DomainTypeProfileBuilder(DomainTypeProfileBuilderApi):
    def __init__(self, logger, columnInfos, prepopulated_referenceId=None):
        """
        Constructs afor a given dataset.
        :param logger: Logger for telemetry events.
        :return:
        """
        background_process = BackgroundProcess(r'Microsoft.ProgramSynthesis.Python.CodeAccelerator.Internals.dll', '04/18/2020 05:15:37', process_terminator)
        assert background_process._process_state == _ProcessState.RUNNING
        super().__init__(background_process, logger, columnInfos, prepopulated_referenceId)

    def __del__(self):
        super().__del__()

    __slots__ = []

    @classmethod
    def prepopulated_object_builder(cls, prepopulated_referenceId):
        """
        Method to construct DomainTypeProfileBuilder object if equivalent C# object is already created
        """

        return DomainTypeProfileBuilder(None, None, prepopulated_referenceId)
