# Copyright (c) Microsoft Corporation.  All rights reserved.
# This file is auto-generated. Do not make manual changes.

from .protobuf_objects import ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseDispatchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseFetchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .background_process import BackgroundProcess, _ProcessState
from .cache_manager import CacheManager
from .protobuf_objects.background_process_terminate import process_terminator
from .null_value_converter_utils import NullValueConverterUtils
from . import python_logger
from . import single_column_profile_result


class DomainTypeProfileResultApi(object):
    def get_profile_for_column(self, columnName):
        """
        Retrieve the profile corresponding to a single column.
        :param columnName: The name of the column. See .
        :return: Afor .
        """

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DomainTypeProfileResult' object from request and set parameters
        domain_type_profile_result_request = request.iDomainTypeProfileResult
        NullValueConverterUtils.convert_to_pb_nullable_string(domain_type_profile_result_request.i_In_DomainTypeProfileResult_GetProfileForColumn.columnName, columnName)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DomainTypeProfileResult.GetProfileForColumn
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        domain_type_profile_result_response = response.iDomainTypeProfileResult.i_Out_DomainTypeProfileResult_GetProfileForColumn
        to_return = NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(domain_type_profile_result_response.result, self._cache_manager.get_object, single_column_profile_result.SingleColumnProfileResult.prepopulated_object_builder)
        return to_return

    def get_column_names(self):
        def _convert_from_pb_21(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            return [NullValueConverterUtils.convert_from_pb_nullable_string(python_object) for python_object in protobuf_object.Value]


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DomainTypeProfileResult' object from request and set parameters
        domain_type_profile_result_request = request.iDomainTypeProfileResult
        domain_type_profile_result_request.i_In_DomainTypeProfileResult_get_ColumnNames.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DomainTypeProfileResult.get_ColumnNames
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        domain_type_profile_result_response = response.iDomainTypeProfileResult.i_Out_DomainTypeProfileResult_get_ColumnNames
        to_return = _convert_from_pb_21(domain_type_profile_result_response.result)
        return to_return

    def get_telemetry_testing_data(self):
        """
        Gets the testing telemetry events.
        :return: The testing telemetry events as tuples of event name and session type.
        """
        def _convert_from_pb_22(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None

            return NullValueConverterUtils.convert_from_pb_nullable_string(protobuf_object.item1), NullValueConverterUtils.convert_from_pb_nullable_string(protobuf_object.item2)

        def _convert_from_pb_23(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            python_object = []
            for inner_pb_object in protobuf_object.Value:
                python_object.append(_convert_from_pb_22(inner_pb_object))
            return python_object


        def _convert_from_pb_24(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            python_object = []
            for inner_pb_object in protobuf_object.Value:
                python_object.append(_convert_from_pb_23(inner_pb_object))
            return python_object


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DomainTypeProfileResult' object from request and set parameters
        domain_type_profile_result_request = request.iDomainTypeProfileResult
        domain_type_profile_result_request.i_In_DomainTypeProfileResult_GetTelemetryTestingData.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DomainTypeProfileResult.GetTelemetryTestingData
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        domain_type_profile_result_response = response.iDomainTypeProfileResult.i_Out_DomainTypeProfileResult_GetTelemetryTestingData
        to_return = _convert_from_pb_24(domain_type_profile_result_response.result)
        return to_return

    def get_python_logger(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'DomainTypeProfileResult' object from request and set parameters
        domain_type_profile_result_request = request.iDomainTypeProfileResult
        domain_type_profile_result_request.i_In_DomainTypeProfileResult_get_PythonLogger.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DomainTypeProfileResult.get_PythonLogger
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        domain_type_profile_result_response = response.iDomainTypeProfileResult.i_Out_DomainTypeProfileResult_get_PythonLogger
        to_return = NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(domain_type_profile_result_response.result, self._cache_manager.get_object, python_logger.PythonLogger.prepopulated_object_builder)
        return to_return

    def __init__(self, background_process, prepopulated_referenceId):
        assert background_process is not None
        assert prepopulated_referenceId is not None
        self._background_process = background_process
        self._cache_manager = CacheManager(id(background_process))

        # This object is already created in C#, just initialize the referenceId.
        self.referenceId = prepopulated_referenceId
        self._cache_manager.add_object(self.referenceId, self)
    column_names = property(get_column_names, None, None, 'accessor for ColumnNames')
    python_logger = property(get_python_logger, None, None, 'accessor for PythonLogger')
    def __del__(self):

        # If we haven't initialized successfully, just return
        if not hasattr(self, 'referenceId'):
            return
        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId
        request.DeleteFromCache.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, just return
        if received_bytes is None:
            return

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by DomainTypeProfileResult.__del__
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    __slots__ = ['_background_process', '_cache_manager', 'referenceId', '__weakref__']


class DomainTypeProfileResult(DomainTypeProfileResultApi):
    def __init__(self, prepopulated_referenceId):
        background_process = BackgroundProcess(r'Microsoft.ProgramSynthesis.Python.CodeAccelerator.Internals.dll', '04/18/2020 05:15:37', process_terminator)
        assert background_process._process_state == _ProcessState.RUNNING
        super().__init__(background_process, prepopulated_referenceId)

    def __del__(self):
        super().__del__()

    __slots__ = []

    @classmethod
    def prepopulated_object_builder(cls, prepopulated_referenceId):
        """
        Method to construct DomainTypeProfileResult object if equivalent C# object is already created
        """

        return DomainTypeProfileResult(prepopulated_referenceId)
