# Copyright (c) Microsoft Corporation.  All rights reserved.
# This file is auto-generated. Do not make manual changes.

from .protobuf_objects import ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseDispatchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseFetchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .background_process import BackgroundProcess, _ProcessState
from .cache_manager import CacheManager
from .protobuf_objects.background_process_terminate import process_terminator
from .null_value_converter_utils import NullValueConverterUtils


class FieldPositionsApi(object):
    def __init__(self, background_process, start, end, prepopulated_referenceId=None):
        """
        Constructs a field positions.
        :param start: The starting position.
        :param end: The ending position.
        :return:
        """
        assert background_process is not None
        self._background_process = background_process
        self._cache_manager = CacheManager(id(background_process))

        # if object was already created in C#, just initialize the referenceId.
        if prepopulated_referenceId is not None:
            self.referenceId = prepopulated_referenceId
            self._cache_manager.add_object(self.referenceId, self)
            return
        # else if object is constructed in Python, then create an equivalent in C#.

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher


        # Extract 'FieldPositions' object from request and set parameters
        field_positions_request = request.iFieldPositions
        field_positions_request.i_In_FieldPositions___init__.start = start
        NullValueConverterUtils.convert_to_pb_nullable_int32(field_positions_request.i_In_FieldPositions___init__.end, end)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by FieldPositions..ctor
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)
        # Ensure we have a valid referenceId
        if response.referenceId is 0:
            raise ValueError('Failed to create FieldPositions object.')
        self.referenceId = response.referenceId
        # Cache the object
        self._cache_manager.add_object(self.referenceId, self)

    def get_start(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'FieldPositions' object from request and set parameters
        field_positions_request = request.iFieldPositions
        field_positions_request.i_In_FieldPositions_get_Start.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by FieldPositions.get_Start
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        field_positions_response = response.iFieldPositions.i_Out_FieldPositions_get_Start
        to_return = field_positions_response.result
        return to_return

    def get_end(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'FieldPositions' object from request and set parameters
        field_positions_request = request.iFieldPositions
        field_positions_request.i_In_FieldPositions_get_End.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by FieldPositions.get_End
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        field_positions_response = response.iFieldPositions.i_Out_FieldPositions_get_End
        to_return = NullValueConverterUtils.convert_from_pb_nullable_int32(field_positions_response.result)
        return to_return

    start = property(get_start, None, None, 'accessor for Start')
    end = property(get_end, None, None, 'accessor for End')
    def __del__(self):

        # If we haven't initialized successfully, just return
        if not hasattr(self, 'referenceId'):
            return
        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId
        request.DeleteFromCache.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, just return
        if received_bytes is None:
            return

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by FieldPositions.__del__
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    __slots__ = ['_background_process', '_cache_manager', 'referenceId', '__weakref__']


class FieldPositions(FieldPositionsApi):
    def __init__(self, start, end, prepopulated_referenceId=None):
        """
        Constructs a field positions.
        :param start: The starting position.
        :param end: The ending position.
        :return:
        """
        background_process = BackgroundProcess(r'Microsoft.ProgramSynthesis.Python.CodeAccelerator.Internals.dll', '04/18/2020 05:15:37', process_terminator)
        assert background_process._process_state == _ProcessState.RUNNING
        super().__init__(background_process, start, end, prepopulated_referenceId)

    def __del__(self):
        super().__del__()

    __slots__ = []

    @classmethod
    def prepopulated_object_builder(cls, prepopulated_referenceId):
        """
        Method to construct FieldPositions object if equivalent C# object is already created
        """

        return FieldPositions(None, None, prepopulated_referenceId)
