# Copyright (c) Microsoft Corporation.  All rights reserved.
# This file is auto-generated. Do not make manual changes.

from .protobuf_objects import ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseDispatchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseFetchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .background_process import BackgroundProcess, _ProcessState
from .cache_manager import CacheManager
from .protobuf_objects.background_process_terminate import process_terminator
from .null_value_converter_utils import NullValueConverterUtils
from . import find_patterns_learn_result
from . import python_logger
from . import regex_token_spec


class FindPatternsBuilderApi(object):
    def __init__(self, background_process, logger, inputs, prepopulated_referenceId=None):
        """
        Construct a find patterns builder from a sequence of input string , andthe given telemetry options.
        :param logger: Logger for telemetry events.
        :param inputs: The set of strings to learn patterns from.
        :return:
        """
        def _convert_to_pb_10(protobuf_object, python_object) -> None:
            """
            Converts the python_object and sets converted object in appropriate fields of protobuf_object. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if python_object is None:
                protobuf_object.IsNullValue = True
                return

            if len(python_object) == 0:
                protobuf_object.Value.extend(python_object)
                return

            for inner_py_object in python_object:
                inner_pb_object = protobuf_object.Value.add()
                NullValueConverterUtils.convert_to_pb_nullable_string(inner_pb_object, inner_py_object)

        assert background_process is not None
        self._background_process = background_process
        self._cache_manager = CacheManager(id(background_process))

        # if object was already created in C#, just initialize the referenceId.
        if prepopulated_referenceId is not None:
            self.referenceId = prepopulated_referenceId
            self._cache_manager.add_object(self.referenceId, self)
            return
        # else if object is constructed in Python, then create an equivalent in C#.

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher


        # Extract 'FindPatternsBuilder' object from request and set parameters
        find_patterns_builder_request = request.iFindPatternsBuilder
        NullValueConverterUtils.convert_to_pb_XplatPyNetCustomObject(find_patterns_builder_request.i_In_FindPatternsBuilder___init__.logger, logger)
        _convert_to_pb_10(find_patterns_builder_request.i_In_FindPatternsBuilder___init__.inputs, inputs)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by FindPatternsBuilder..ctor
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)
        # Ensure we have a valid referenceId
        if response.referenceId is 0:
            raise ValueError('Failed to create FindPatternsBuilder object.')
        self.referenceId = response.referenceId
        # Cache the object
        self._cache_manager.add_object(self.referenceId, self)

    def learn(self, newLogger, inSameCluster, inDifferentClusters, defaultTokens, otherRegexTokens, useLongConstantOptimization, includeOutlierPatterns):
        """
        Learn the patterns in the input strings of the builder.
        :return:
        """
        def _convert_to_pb_11(protobuf_object, python_object) -> None:
            """
            Converts the python_object and sets converted object in appropriate fields of protobuf_object. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if python_object is None:
                protobuf_object.IsNullValue = True
                return

            if len(python_object) == 0:
                protobuf_object.Value.extend(python_object)
                return

            for inner_py_object in python_object:
                inner_pb_object = protobuf_object.Value.add()
                NullValueConverterUtils.convert_to_pb_nullable_string(inner_pb_object, inner_py_object)


        def _convert_to_pb_12(protobuf_object, python_object) -> None:
            """
            Converts the python_object and sets converted object in appropriate fields of protobuf_object. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if python_object is None:
                protobuf_object.IsNullValue = True
                return
            if len(python_object) == 0:
                protobuf_object.Value.extend(python_object)
                return

            for inner_py_object in python_object:
                inner_pb_object = protobuf_object.Value.add()
                _convert_to_pb_11(inner_pb_object, inner_py_object)


        def _convert_to_pb_13(protobuf_object, python_object) -> None:
            """
            Converts the python_object and sets converted object in appropriate fields of protobuf_object. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if python_object is None:
                protobuf_object.IsNullValue = True
                return

            if len(python_object) == 0:
                protobuf_object.Value.extend(python_object)
                return

            for inner_py_object in python_object:
                inner_pb_object = protobuf_object.Value.add()
                NullValueConverterUtils.convert_to_pb_nullable_string(inner_pb_object, inner_py_object)


        def _convert_to_pb_14(protobuf_object, python_object) -> None:
            """
            Converts the python_object and sets converted object in appropriate fields of protobuf_object. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if python_object is None:
                protobuf_object.IsNullValue = True
                return
            if len(python_object) == 0:
                protobuf_object.Value.extend(python_object)
                return

            for inner_py_object in python_object:
                inner_pb_object = protobuf_object.Value.add()
                _convert_to_pb_13(inner_pb_object, inner_py_object)


        def _convert_to_pb_15(protobuf_object, python_object) -> None:
            """
            Converts the python_object and sets converted object in appropriate fields of protobuf_object. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if python_object is None:
                protobuf_object.IsNullValue = True
                return

            if len(python_object) == 0:
                protobuf_object.Value.extend(python_object)
                return

            for inner_py_object in python_object:
                inner_pb_object = protobuf_object.Value.add()
                NullValueConverterUtils.convert_to_pb_nullable_string(inner_pb_object, inner_py_object)


        def _convert_to_pb_16(protobuf_object, python_object) -> None:
            """
            Converts the python_object and sets converted object in appropriate fields of protobuf_object. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if python_object is None:
                protobuf_object.IsNullValue = True
                return

            if len(python_object) == 0:
                protobuf_object.Value.extend(python_object)
                return

            for inner_py_object in python_object:
                inner_pb_object = protobuf_object.Value.add()
                NullValueConverterUtils.convert_to_pb_XplatPyNetCustomObject(inner_pb_object, inner_py_object)


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'FindPatternsBuilder' object from request and set parameters
        find_patterns_builder_request = request.iFindPatternsBuilder
        NullValueConverterUtils.convert_to_pb_XplatPyNetCustomObject(find_patterns_builder_request.i_In_FindPatternsBuilder_Learn.newLogger, newLogger)
        _convert_to_pb_12(find_patterns_builder_request.i_In_FindPatternsBuilder_Learn.inSameCluster, inSameCluster)
        _convert_to_pb_14(find_patterns_builder_request.i_In_FindPatternsBuilder_Learn.inDifferentClusters, inDifferentClusters)
        _convert_to_pb_15(find_patterns_builder_request.i_In_FindPatternsBuilder_Learn.defaultTokens, defaultTokens)
        _convert_to_pb_16(find_patterns_builder_request.i_In_FindPatternsBuilder_Learn.otherRegexTokens, otherRegexTokens)
        find_patterns_builder_request.i_In_FindPatternsBuilder_Learn.useLongConstantOptimization = useLongConstantOptimization
        find_patterns_builder_request.i_In_FindPatternsBuilder_Learn.includeOutlierPatterns = includeOutlierPatterns
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by FindPatternsBuilder.Learn
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        find_patterns_builder_response = response.iFindPatternsBuilder.i_Out_FindPatternsBuilder_Learn
        to_return = NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(find_patterns_builder_response.result, self._cache_manager.get_object, find_patterns_learn_result.FindPatternsLearnResult.prepopulated_object_builder)
        return to_return

    def get_telemetry_testing_data(self):
        """
        Gets the testing telemetry events.
        :return: The testing telemetry events as tuples of event name and session type.
        """
        def _convert_from_pb_25(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None

            return NullValueConverterUtils.convert_from_pb_nullable_string(protobuf_object.item1), NullValueConverterUtils.convert_from_pb_nullable_string(protobuf_object.item2)

        def _convert_from_pb_26(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            python_object = []
            for inner_pb_object in protobuf_object.Value:
                python_object.append(_convert_from_pb_25(inner_pb_object))
            return python_object


        def _convert_from_pb_27(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            python_object = []
            for inner_pb_object in protobuf_object.Value:
                python_object.append(_convert_from_pb_26(inner_pb_object))
            return python_object


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'FindPatternsBuilder' object from request and set parameters
        find_patterns_builder_request = request.iFindPatternsBuilder
        find_patterns_builder_request.i_In_FindPatternsBuilder_GetTelemetryTestingData.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by FindPatternsBuilder.GetTelemetryTestingData
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        find_patterns_builder_response = response.iFindPatternsBuilder.i_Out_FindPatternsBuilder_GetTelemetryTestingData
        to_return = _convert_from_pb_27(find_patterns_builder_response.result)
        return to_return

    def get_python_logger(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'FindPatternsBuilder' object from request and set parameters
        find_patterns_builder_request = request.iFindPatternsBuilder
        find_patterns_builder_request.i_In_FindPatternsBuilder_get_PythonLogger.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by FindPatternsBuilder.get_PythonLogger
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        find_patterns_builder_response = response.iFindPatternsBuilder.i_Out_FindPatternsBuilder_get_PythonLogger
        to_return = NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(find_patterns_builder_response.result, self._cache_manager.get_object, python_logger.PythonLogger.prepopulated_object_builder)
        return to_return

    python_logger = property(get_python_logger, None, None, 'accessor for PythonLogger')
    def __del__(self):

        # If we haven't initialized successfully, just return
        if not hasattr(self, 'referenceId'):
            return
        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId
        request.DeleteFromCache.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, just return
        if received_bytes is None:
            return

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by FindPatternsBuilder.__del__
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    __slots__ = ['_background_process', '_cache_manager', 'referenceId', '__weakref__']


class FindPatternsBuilder(FindPatternsBuilderApi):
    def __init__(self, logger, inputs, prepopulated_referenceId=None):
        """
        Construct a find patterns builder from a sequence of input string , andthe given telemetry options.
        :param logger: Logger for telemetry events.
        :param inputs: The set of strings to learn patterns from.
        :return:
        """
        background_process = BackgroundProcess(r'Microsoft.ProgramSynthesis.Python.CodeAccelerator.Internals.dll', '04/18/2020 05:15:37', process_terminator)
        assert background_process._process_state == _ProcessState.RUNNING
        super().__init__(background_process, logger, inputs, prepopulated_referenceId)

    def __del__(self):
        super().__del__()

    __slots__ = []

    @classmethod
    def prepopulated_object_builder(cls, prepopulated_referenceId):
        """
        Method to construct FindPatternsBuilder object if equivalent C# object is already created
        """

        return FindPatternsBuilder(None, None, prepopulated_referenceId)
