# Copyright (c) Microsoft Corporation.  All rights reserved.
# This file is auto-generated. Do not make manual changes.

from .protobuf_objects import ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseDispatchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseFetchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .background_process import BackgroundProcess, _ProcessState
from .cache_manager import CacheManager
from .protobuf_objects.background_process_terminate import process_terminator
from .null_value_converter_utils import NullValueConverterUtils
from . import python_logger


class FindPatternsLearnResultApi(object):
    def code(self, task, target, functionName):
        """
        Return a code fragment that either classifies strings into the learned patterns, or asserts thatstrings fall into one of the learned patterns based on the value of the .
        :param task: The task that is to be achieved by the code fragment produces.Must be one ofor .
        :param target: The target framework for the code generated. Must be one of "auto", "pandas" or "pyspark".
        :param functionName: The name of the function in the generated code that performs the specified task on an input string.
        :return:
        """

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'FindPatternsLearnResult' object from request and set parameters
        find_patterns_learn_result_request = request.iFindPatternsLearnResult
        NullValueConverterUtils.convert_to_pb_nullable_string(find_patterns_learn_result_request.i_In_FindPatternsLearnResult_Code.task, task)
        NullValueConverterUtils.convert_to_pb_nullable_string(find_patterns_learn_result_request.i_In_FindPatternsLearnResult_Code.target, target)
        NullValueConverterUtils.convert_to_pb_nullable_string(find_patterns_learn_result_request.i_In_FindPatternsLearnResult_Code.functionName, functionName)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by FindPatternsLearnResult.Code
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        find_patterns_learn_result_response = response.iFindPatternsLearnResult.i_Out_FindPatternsLearnResult_Code
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(find_patterns_learn_result_response.result)
        return to_return

    def get_classify_task(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'FindPatternsLearnResult' object from request and set parameters
        find_patterns_learn_result_request = request.iFindPatternsLearnResult
        find_patterns_learn_result_request.i_In_FindPatternsLearnResult_get_ClassifyTask.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by FindPatternsLearnResult.get_ClassifyTask
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        find_patterns_learn_result_response = response.iFindPatternsLearnResult.i_Out_FindPatternsLearnResult_get_ClassifyTask
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(find_patterns_learn_result_response.result)
        return to_return

    def get_check_task(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'FindPatternsLearnResult' object from request and set parameters
        find_patterns_learn_result_request = request.iFindPatternsLearnResult
        find_patterns_learn_result_request.i_In_FindPatternsLearnResult_get_CheckTask.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by FindPatternsLearnResult.get_CheckTask
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        find_patterns_learn_result_response = response.iFindPatternsLearnResult.i_Out_FindPatternsLearnResult_get_CheckTask
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(find_patterns_learn_result_response.result)
        return to_return

    def get_regexes(self):
        def _convert_from_pb_28(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            return [NullValueConverterUtils.convert_from_pb_nullable_string(python_object) for python_object in protobuf_object.Value]


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'FindPatternsLearnResult' object from request and set parameters
        find_patterns_learn_result_request = request.iFindPatternsLearnResult
        find_patterns_learn_result_request.i_In_FindPatternsLearnResult_get_Regexes.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by FindPatternsLearnResult.get_Regexes
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        find_patterns_learn_result_response = response.iFindPatternsLearnResult.i_Out_FindPatternsLearnResult_get_Regexes
        to_return = _convert_from_pb_28(find_patterns_learn_result_response.result)
        return to_return

    def get_telemetry_testing_data(self):
        """
        Gets the testing telemetry events.
        :return: The testing telemetry events as tuples of event name and session type.
        """
        def _convert_from_pb_29(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None

            return NullValueConverterUtils.convert_from_pb_nullable_string(protobuf_object.item1), NullValueConverterUtils.convert_from_pb_nullable_string(protobuf_object.item2)

        def _convert_from_pb_30(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            python_object = []
            for inner_pb_object in protobuf_object.Value:
                python_object.append(_convert_from_pb_29(inner_pb_object))
            return python_object


        def _convert_from_pb_31(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            python_object = []
            for inner_pb_object in protobuf_object.Value:
                python_object.append(_convert_from_pb_30(inner_pb_object))
            return python_object


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'FindPatternsLearnResult' object from request and set parameters
        find_patterns_learn_result_request = request.iFindPatternsLearnResult
        find_patterns_learn_result_request.i_In_FindPatternsLearnResult_GetTelemetryTestingData.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by FindPatternsLearnResult.GetTelemetryTestingData
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        find_patterns_learn_result_response = response.iFindPatternsLearnResult.i_Out_FindPatternsLearnResult_GetTelemetryTestingData
        to_return = _convert_from_pb_31(find_patterns_learn_result_response.result)
        return to_return

    def get_python_logger(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'FindPatternsLearnResult' object from request and set parameters
        find_patterns_learn_result_request = request.iFindPatternsLearnResult
        find_patterns_learn_result_request.i_In_FindPatternsLearnResult_get_PythonLogger.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by FindPatternsLearnResult.get_PythonLogger
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        find_patterns_learn_result_response = response.iFindPatternsLearnResult.i_Out_FindPatternsLearnResult_get_PythonLogger
        to_return = NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(find_patterns_learn_result_response.result, self._cache_manager.get_object, python_logger.PythonLogger.prepopulated_object_builder)
        return to_return

    def __init__(self, background_process, prepopulated_referenceId):
        assert background_process is not None
        assert prepopulated_referenceId is not None
        self._background_process = background_process
        self._cache_manager = CacheManager(id(background_process))

        # This object is already created in C#, just initialize the referenceId.
        self.referenceId = prepopulated_referenceId
        self._cache_manager.add_object(self.referenceId, self)
    def _get_error(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'FindPatternsLearnResult' object from request and set parameters
        find_patterns_learn_result_request = request.iFindPatternsLearnResult
        find_patterns_learn_result_request.i_In_FindPatternsLearnResult__get_Error.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by FindPatternsLearnResult.Error
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        find_patterns_learn_result_response = response.iFindPatternsLearnResult.i_Out_FindPatternsLearnResult__get_Error
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(find_patterns_learn_result_response.result)
        return to_return

    classify_task = property(get_classify_task, None, None, 'accessor for ClassifyTask')
    check_task = property(get_check_task, None, None, 'accessor for CheckTask')
    regexes = property(get_regexes, None, None, 'accessor for Regexes')
    python_logger = property(get_python_logger, None, None, 'accessor for PythonLogger')
    error = property(_get_error, None, None, 'accessor for Error')
    def __del__(self):

        # If we haven't initialized successfully, just return
        if not hasattr(self, 'referenceId'):
            return
        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId
        request.DeleteFromCache.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, just return
        if received_bytes is None:
            return

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by FindPatternsLearnResult.__del__
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    __slots__ = ['_background_process', '_cache_manager', 'referenceId', '__weakref__']


class FindPatternsLearnResult(FindPatternsLearnResultApi):
    def __init__(self, prepopulated_referenceId):
        background_process = BackgroundProcess(r'Microsoft.ProgramSynthesis.Python.CodeAccelerator.Internals.dll', '04/18/2020 05:15:37', process_terminator)
        assert background_process._process_state == _ProcessState.RUNNING
        super().__init__(background_process, prepopulated_referenceId)

    def __del__(self):
        super().__del__()

    __slots__ = []

    @classmethod
    def prepopulated_object_builder(cls, prepopulated_referenceId):
        """
        Method to construct FindPatternsLearnResult object if equivalent C# object is already created
        """

        return FindPatternsLearnResult(prepopulated_referenceId)
