# Copyright (c) Microsoft Corporation.  All rights reserved.
# This file is auto-generated. Do not make manual changes.

class NullValueConverterUtils(object):
    @classmethod
    def convert_to_pb_nullable_double(cls, protobuf_object, python_object) -> None:
        """
        Converts the 'double?' value into 'nullable_double'. If value was null, sets 'IsNullValue' to true.
        Otherwise sets the 'Value' property of 'nullable_double'.
        :param protobuf_object: Protobuf object whose value will be set
        :param python_object: Python object that we are trying to set in pb object
        :return:
        """
        if python_object is None:
            protobuf_object.IsNullValue = True
        else:
            protobuf_object.Value = python_object

    @classmethod
    def convert_from_pb_nullable_double(cls, protobuf_object):
        """
        Extracts the 'double?' value from 'nullable_double'. If 'IsNullValue' was false, returns None.
        Otherwise returns the value of 'Value' property of 'nullable_double'.
        :param protobuf_object:
        :return:
        """
        return None if protobuf_object.IsNullValue else protobuf_object.Value

    @classmethod
    def convert_to_pb_nullable_float(cls, protobuf_object, python_object) -> None:
        """
        Converts the 'float?' value into 'nullable_float'. If value was null, sets 'IsNullValue' to true.
        Otherwise sets the 'Value' property of 'nullable_float'.
        :param protobuf_object: Protobuf object whose value will be set
        :param python_object: Python object that we are trying to set in pb object
        :return:
        """
        if python_object is None:
            protobuf_object.IsNullValue = True
        else:
            protobuf_object.Value = python_object

    @classmethod
    def convert_from_pb_nullable_float(cls, protobuf_object):
        """
        Extracts the 'float?' value from 'nullable_float'. If 'IsNullValue' was false, returns None.
        Otherwise returns the value of 'Value' property of 'nullable_float'.
        :param protobuf_object:
        :return:
        """
        return None if protobuf_object.IsNullValue else protobuf_object.Value

    @classmethod
    def convert_to_pb_nullable_int32(cls, protobuf_object, python_object) -> None:
        """
        Converts the 'int?' value into 'nullable_int32'. If value was null, sets 'IsNullValue' to true.
        Otherwise sets the 'Value' property of 'nullable_int32'.
        :param protobuf_object: Protobuf object whose value will be set
        :param python_object: Python object that we are trying to set in pb object
        :return:
        """
        if python_object is None:
            protobuf_object.IsNullValue = True
        else:
            protobuf_object.Value = python_object

    @classmethod
    def convert_from_pb_nullable_int32(cls, protobuf_object):
        """
        Extracts the 'int?' value from 'nullable_int32'. If 'IsNullValue' was false, returns None.
        Otherwise returns the value of 'Value' property of 'nullable_int32'.
        :param protobuf_object:
        :return:
        """
        return None if protobuf_object.IsNullValue else protobuf_object.Value

    @classmethod
    def convert_to_pb_nullable_int64(cls, protobuf_object, python_object) -> None:
        """
        Converts the 'long?' value into 'nullable_int64'. If value was null, sets 'IsNullValue' to true.
        Otherwise sets the 'Value' property of 'nullable_int64'.
        :param protobuf_object: Protobuf object whose value will be set
        :param python_object: Python object that we are trying to set in pb object
        :return:
        """
        if python_object is None:
            protobuf_object.IsNullValue = True
        else:
            protobuf_object.Value = python_object

    @classmethod
    def convert_from_pb_nullable_int64(cls, protobuf_object):
        """
        Extracts the 'long?' value from 'nullable_int64'. If 'IsNullValue' was false, returns None.
        Otherwise returns the value of 'Value' property of 'nullable_int64'.
        :param protobuf_object:
        :return:
        """
        return None if protobuf_object.IsNullValue else protobuf_object.Value

    @classmethod
    def convert_to_pb_nullable_uint32(cls, protobuf_object, python_object) -> None:
        """
        Converts the 'uint?' value into 'nullable_uint32'. If value was null, sets 'IsNullValue' to true.
        Otherwise sets the 'Value' property of 'nullable_uint32'.
        :param protobuf_object: Protobuf object whose value will be set
        :param python_object: Python object that we are trying to set in pb object
        :return:
        """
        if python_object is None:
            protobuf_object.IsNullValue = True
        else:
            protobuf_object.Value = python_object

    @classmethod
    def convert_from_pb_nullable_uint32(cls, protobuf_object):
        """
        Extracts the 'uint?' value from 'nullable_uint32'. If 'IsNullValue' was false, returns None.
        Otherwise returns the value of 'Value' property of 'nullable_uint32'.
        :param protobuf_object:
        :return:
        """
        return None if protobuf_object.IsNullValue else protobuf_object.Value

    @classmethod
    def convert_to_pb_nullable_uint64(cls, protobuf_object, python_object) -> None:
        """
        Converts the 'ulong?' value into 'nullable_uint64'. If value was null, sets 'IsNullValue' to true.
        Otherwise sets the 'Value' property of 'nullable_uint64'.
        :param protobuf_object: Protobuf object whose value will be set
        :param python_object: Python object that we are trying to set in pb object
        :return:
        """
        if python_object is None:
            protobuf_object.IsNullValue = True
        else:
            protobuf_object.Value = python_object

    @classmethod
    def convert_from_pb_nullable_uint64(cls, protobuf_object):
        """
        Extracts the 'ulong?' value from 'nullable_uint64'. If 'IsNullValue' was false, returns None.
        Otherwise returns the value of 'Value' property of 'nullable_uint64'.
        :param protobuf_object:
        :return:
        """
        return None if protobuf_object.IsNullValue else protobuf_object.Value

    @classmethod
    def convert_to_pb_nullable_bool(cls, protobuf_object, python_object) -> None:
        """
        Converts the 'bool?' value into 'nullable_bool'. If value was null, sets 'IsNullValue' to true.
        Otherwise sets the 'Value' property of 'nullable_bool'.
        :param protobuf_object: Protobuf object whose value will be set
        :param python_object: Python object that we are trying to set in pb object
        :return:
        """
        if python_object is None:
            protobuf_object.IsNullValue = True
        else:
            protobuf_object.Value = python_object

    @classmethod
    def convert_from_pb_nullable_bool(cls, protobuf_object):
        """
        Extracts the 'bool?' value from 'nullable_bool'. If 'IsNullValue' was false, returns None.
        Otherwise returns the value of 'Value' property of 'nullable_bool'.
        :param protobuf_object:
        :return:
        """
        return None if protobuf_object.IsNullValue else protobuf_object.Value

    @classmethod
    def convert_to_pb_nullable_string(cls, protobuf_object, python_object) -> None:
        """
        Converts the 'string' value into 'nullable_string'. If value was null, sets 'IsNullValue' to true.
        Otherwise sets the 'Value' property of 'nullable_string'.
        :param protobuf_object: Protobuf object whose value will be set
        :param python_object: Python object that we are trying to set in pb object
        :return:
        """
        if python_object is None:
            protobuf_object.IsNullValue = True
        else:
            protobuf_object.Value = python_object

    @classmethod
    def convert_from_pb_nullable_string(cls, protobuf_object):
        """
        Extracts the 'string' value from 'nullable_string'. If 'IsNullValue' was false, returns None.
        Otherwise returns the value of 'Value' property of 'nullable_string'.
        :param protobuf_object:
        :return:
        """
        return None if protobuf_object.IsNullValue else protobuf_object.Value

    @classmethod
    def convert_to_pb_nullable_datetime(cls, protobuf_object, python_object) -> None:
        """
        Converts the 'System.DateTime?' value into 'nullable_datetime'. If value was null, sets 'IsNullValue' to true.
        Otherwise sets the 'Value' property of 'nullable_datetime'.
        :param protobuf_object: Protobuf object whose value will be set
        :param python_object: Python object that we are trying to set in pb object
        :return:
        """
        if python_object is None:
            protobuf_object.IsNullValue = True
        else:
            protobuf_object.Value.FromDatetime(python_object)

    @classmethod
    def convert_from_pb_nullable_datetime(cls, protobuf_object):
        """
        Extracts the 'System.DateTime?' value from 'nullable_datetime'. If 'IsNullValue' was false, returns None.
        Otherwise returns the value of 'Value' property of 'nullable_datetime'.
        :param protobuf_object:
        :return:
        """
        return None if protobuf_object.IsNullValue else protobuf_object.Value.ToDatetime()

    @classmethod
    def convert_to_pb_XplatPyNetCustomObject(cls, protobuf_object, python_object) -> None:
        """
        Converts the 'object' value into 'XplatPyNetCustomObject'. If value was null, sets 'IsNullValue' to true.
        This is a special converter that does more than setting the `Value` property. XplatPyNetCustomObject represents
        the C# objects by referenceId. It sets the referenceId of :python_object into `Value` property. If :python_object
        is None, then sets `IsNullValue` field.
        :param protobuf_object: Protobuf object whose value will be set
        :param python_object: Python object that we are trying to set in pb object
        :return:
        """
        if python_object is None:
            protobuf_object.IsNullValue = True
        else:
            protobuf_object.Value = python_object.referenceId

    @classmethod
    def convert_from_pb_XplatPyNetCustomObject(cls, protobuf_object, cache_object_getter, prepopulated_object_builder):
        """
        Extracts the 'object' value from 'XplatPyNetCustomObject'. If 'IsNullValue' was false, returns None.
        This is a special converter that does more than extracting the `Value` property. XplatPyNetCustomObject represents
        the C# objects by referenceId. It extracts the referenceId from `Value` property and checks if it is in cache
        using :cache_object_getter: method. If it is not present, then create an object with prepopulated_referenceId using
        :prepopulated_object_builder: method and returns it.
        :param protobuf_object:
        :return:
        """
        if protobuf_object.IsNullValue:
            return None
        referenceId = protobuf_object.Value

        # Check if this object was created on Python side
        to_return = cache_object_getter(referenceId)

        # If not, this object is created on C# side. Create the Python equivalent (which will be cached) and return.
        return prepopulated_object_builder(referenceId) if to_return is None else to_return
    @classmethod
    def convert_to_pb_XplatPyNetFetcherObject(cls, protobuf_object, python_object, cache_object_setter) -> None:
        """
        Converts the 'object' value into 'XplatPyNetFetcherObject'. If value was null, sets 'IsNullValue' to true.
        This is a special converter that does more than setting the `Value` property. XplatPyNetFetcherObject represents
        the Python streaming objects by their id referenceId. It sets the referenceId of :python_object into `Value` property. If :python_object
        is None, then sets `IsNullValue` field.
        :param protobuf_object: Protobuf object whose value will be set
        :param python_object: Python object that we are trying to set in pb object
        :return:
        """
        if python_object is None:
            protobuf_object.IsNullValue = True
        else:
            protobuf_object.Value = cache_object_setter(python_object)

    @classmethod
    def convert_from_pb_XplatPyNetFetcherObject(cls, protobuf_object, cache_object_getter):
        """
        Extracts the 'object' value from 'XplatPyNetFetcherObject'. If 'IsNullValue' was false, returns None.
        This is a special converter that does more than extracting the `Value` property. XplatPyNetFetcherObject represents
        the Python streaming objects by referenceId. It extracts the referenceId from `Value` property and returns the
        underlying streaming object from cache using :cache_object_getter: method.
        :param protobuf_object:
        :return:
        """
        if protobuf_object.IsNullValue:
            return None
        referenceId = protobuf_object.Value

        # Return the fetcher object
        return cache_object_getter(referenceId)
