# Copyright (c) Microsoft Corporation.  All rights reserved.
# This file is auto-generated. Do not make manual changes.

from .protobuf_objects import ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseDispatchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseFetchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .background_process import BackgroundProcess, _ProcessState
from .cache_manager import CacheManager
from .protobuf_objects.background_process_terminate import process_terminator
from .null_value_converter_utils import NullValueConverterUtils
from . import python_logger


class PythonLoggerFactoryApi(object):
    def new_base(self, telemetrySettings, sessionType):
        """
        Create a newwith the given settings.
        :param telemetrySettings: Telemetry settings such as opt-out.
        :param sessionType: The sesion type to record in telemetry events.
        :return: The new logger.
        """
        def _convert_to_pb_17(protobuf_object, python_object) -> None:
            """
            Converts the python_object and sets converted object in appropriate fields of protobuf_object. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if python_object is None:
                protobuf_object.IsNullValue = True
                return

            NullValueConverterUtils.convert_to_pb_nullable_string(protobuf_object.item1, python_object[0])
            NullValueConverterUtils.convert_to_pb_nullable_string(protobuf_object.item2, python_object[1])
            protobuf_object.item3 = python_object[2]
            protobuf_object.item4 = python_object[3]

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'PythonLoggerFactory' object from request and set parameters
        python_logger_factory_request = request.iPythonLoggerFactory
        _convert_to_pb_17(python_logger_factory_request.i_In_PythonLoggerFactory_NewBase.telemetrySettings, telemetrySettings)
        NullValueConverterUtils.convert_to_pb_nullable_string(python_logger_factory_request.i_In_PythonLoggerFactory_NewBase.sessionType, sessionType)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by PythonLoggerFactory.NewBase
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        python_logger_factory_response = response.iPythonLoggerFactory.i_Out_PythonLoggerFactory_NewBase
        to_return = NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(python_logger_factory_response.result, self._cache_manager.get_object, python_logger.PythonLogger.prepopulated_object_builder)
        return to_return

    def new_derived(self, basePythonLogger, sessionType):
        """
        Create a newbased on an existing logger.
        :param basePythonLogger: The original logger.
        :param sessionType: The sesion type to record in telemetry events.
        :return: The new logger.
        """

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'PythonLoggerFactory' object from request and set parameters
        python_logger_factory_request = request.iPythonLoggerFactory
        NullValueConverterUtils.convert_to_pb_XplatPyNetCustomObject(python_logger_factory_request.i_In_PythonLoggerFactory_NewDerived.basePythonLogger, basePythonLogger)
        NullValueConverterUtils.convert_to_pb_nullable_string(python_logger_factory_request.i_In_PythonLoggerFactory_NewDerived.sessionType, sessionType)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by PythonLoggerFactory.NewDerived
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        python_logger_factory_response = response.iPythonLoggerFactory.i_Out_PythonLoggerFactory_NewDerived
        to_return = NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(python_logger_factory_response.result, self._cache_manager.get_object, python_logger.PythonLogger.prepopulated_object_builder)
        return to_return

    def __init__(self, background_process, prepopulated_referenceId=None):
        assert background_process is not None
        self._background_process = background_process
        self._cache_manager = CacheManager(id(background_process))

        # if object was already created in C#, just initialize the referenceId.
        if prepopulated_referenceId is not None:
            self.referenceId = prepopulated_referenceId
            self._cache_manager.add_object(self.referenceId, self)
            return
        # else if object is constructed in Python, then create an equivalent in C#.

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher


        # Extract 'PythonLoggerFactory' object from request and set parameters
        python_logger_factory_request = request.iPythonLoggerFactory
        python_logger_factory_request.i_In_PythonLoggerFactory___init__.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by PythonLoggerFactory..ctor
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)
        # Ensure we have a valid referenceId
        if response.referenceId is 0:
            raise ValueError('Failed to create PythonLoggerFactory object.')
        self.referenceId = response.referenceId
        # Cache the object
        self._cache_manager.add_object(self.referenceId, self)

    def __del__(self):

        # If we haven't initialized successfully, just return
        if not hasattr(self, 'referenceId'):
            return
        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId
        request.DeleteFromCache.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, just return
        if received_bytes is None:
            return

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by PythonLoggerFactory.__del__
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    __slots__ = ['_background_process', '_cache_manager', 'referenceId', '__weakref__']


class PythonLoggerFactory(PythonLoggerFactoryApi):
    def __init__(self, prepopulated_referenceId=None):
        background_process = BackgroundProcess(r'Microsoft.ProgramSynthesis.Python.CodeAccelerator.Internals.dll', '04/18/2020 05:15:37', process_terminator)
        assert background_process._process_state == _ProcessState.RUNNING
        super().__init__(background_process, prepopulated_referenceId)

    def __del__(self):
        super().__del__()

    __slots__ = []

    @classmethod
    def prepopulated_object_builder(cls, prepopulated_referenceId):
        """
        Method to construct PythonLoggerFactory object if equivalent C# object is already created
        """

        return PythonLoggerFactory(prepopulated_referenceId)
