# Copyright (c) Microsoft Corporation.  All rights reserved.
# This file is auto-generated. Do not make manual changes.

from .protobuf_objects import ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseDispatchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseFetchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .background_process import BackgroundProcess, _ProcessState
from .cache_manager import CacheManager
from .protobuf_objects.background_process_terminate import process_terminator
from .null_value_converter_utils import NullValueConverterUtils
from . import field_positions


class ReadTextOptionsApi(object):
    def override_program_type(self, programType):
        """
        Override the program type. If non-empty value provided, the program typeis not learned, but the provided type is used instead.
        :param programType: The override-value for program type.
        :return:
        """

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        NullValueConverterUtils.convert_to_pb_nullable_string(read_text_options_request.i_In_ReadTextOptions_OverrideProgramType.programType, programType)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.OverrideProgramType
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    def set_schema_file(self, filename, stream):
        """
        Set the FW schema file name and stream.
        :param filename:
        :param stream:
        :return:
        """

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        NullValueConverterUtils.convert_to_pb_nullable_string(read_text_options_request.i_In_ReadTextOptions_SetSchemaFile.filename, filename)
        NullValueConverterUtils.convert_to_pb_XplatPyNetFetcherObject(read_text_options_request.i_In_ReadTextOptions_SetSchemaFile.stream, stream, self._cache_manager.add_fetcher_object)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.SetSchemaFile
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    def override_delimiter(self, delimiter):
        """
        Override the delimiter. If non-empty value provided, the delimiter is not learned,but the provided value is used instead.
        :param delimiter: The override-value for delimiter.
        :return:
        """

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        NullValueConverterUtils.convert_to_pb_nullable_string(read_text_options_request.i_In_ReadTextOptions_OverrideDelimiter.delimiter, delimiter)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.OverrideDelimiter
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    def override_skip(self, skip):
        """
        Override the skip lines. If non-null value provided, the skip lines are not learned,but the provided value is used instead.
        :param skip: The override-value of skip.
        :return:
        """

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        NullValueConverterUtils.convert_to_pb_nullable_int32(read_text_options_request.i_In_ReadTextOptions_OverrideSkip.skip, skip)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.OverrideSkip
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    def __init__(self, background_process, prepopulated_referenceId=None):
        assert background_process is not None
        self._background_process = background_process
        self._cache_manager = CacheManager(id(background_process))

        # if object was already created in C#, just initialize the referenceId.
        if prepopulated_referenceId is not None:
            self.referenceId = prepopulated_referenceId
            self._cache_manager.add_object(self.referenceId, self)
            return
        # else if object is constructed in Python, then create an equivalent in C#.

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher


        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        read_text_options_request.i_In_ReadTextOptions___init__.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions..ctor
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)
        # Ensure we have a valid referenceId
        if response.referenceId is 0:
            raise ValueError('Failed to create ReadTextOptions object.')
        self.referenceId = response.referenceId
        # Cache the object
        self._cache_manager.add_object(self.referenceId, self)

    def get_delimiter_overridden(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        read_text_options_request.i_In_ReadTextOptions_get_DelimiterOverridden.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.get_DelimiterOverridden
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        read_text_options_response = response.iReadTextOptions.i_Out_ReadTextOptions_get_DelimiterOverridden
        to_return = read_text_options_response.result
        return to_return

    def get_skip_overridden(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        read_text_options_request.i_In_ReadTextOptions_get_SkipOverridden.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.get_SkipOverridden
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        read_text_options_response = response.iReadTextOptions.i_Out_ReadTextOptions_get_SkipOverridden
        to_return = read_text_options_response.result
        return to_return

    def get_program_type(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        read_text_options_request.i_In_ReadTextOptions_get_ProgramType.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.get_ProgramType
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        read_text_options_response = response.iReadTextOptions.i_Out_ReadTextOptions_get_ProgramType
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(read_text_options_response.result)
        return to_return

    def get_lines_to_analyze(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        read_text_options_request.i_In_ReadTextOptions_get_LinesToAnalyze.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.get_LinesToAnalyze
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        read_text_options_response = response.iReadTextOptions.i_Out_ReadTextOptions_get_LinesToAnalyze
        to_return = read_text_options_response.result
        return to_return

    def set_lines_to_analyze(self, value):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        read_text_options_request.i_In_ReadTextOptions_set_LinesToAnalyze.value = value
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.set_LinesToAnalyze
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    def get_encoding(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        read_text_options_request.i_In_ReadTextOptions_get_Encoding.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.get_Encoding
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        read_text_options_response = response.iReadTextOptions.i_Out_ReadTextOptions_get_Encoding
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(read_text_options_response.result)
        return to_return

    def get_delimiter(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        read_text_options_request.i_In_ReadTextOptions_get_Delimiter.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.get_Delimiter
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        read_text_options_response = response.iReadTextOptions.i_Out_ReadTextOptions_get_Delimiter
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(read_text_options_response.result)
        return to_return

    def get_skip(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        read_text_options_request.i_In_ReadTextOptions_get_Skip.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.get_Skip
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        read_text_options_response = response.iReadTextOptions.i_Out_ReadTextOptions_get_Skip
        to_return = read_text_options_response.result
        return to_return

    def get_schema_filename(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        read_text_options_request.i_In_ReadTextOptions_get_SchemaFilename.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.get_SchemaFilename
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        read_text_options_response = response.iReadTextOptions.i_Out_ReadTextOptions_get_SchemaFilename
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(read_text_options_response.result)
        return to_return

    def get_names(self):
        def _convert_from_pb_46(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            return [NullValueConverterUtils.convert_from_pb_nullable_string(python_object) for python_object in protobuf_object.Value]


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        read_text_options_request.i_In_ReadTextOptions_get_Names.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.get_Names
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        read_text_options_response = response.iReadTextOptions.i_Out_ReadTextOptions_get_Names
        to_return = _convert_from_pb_46(read_text_options_response.result)
        return to_return

    def get_colspecs(self):
        def _convert_from_pb_47(protobuf_object, cache_object_getter):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            return [NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(python_object, cache_object_getter, field_positions.FieldPositions.prepopulated_object_builder) for python_object in protobuf_object.Value]


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        read_text_options_request.i_In_ReadTextOptions_get_Colspecs.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.get_Colspecs
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        read_text_options_response = response.iReadTextOptions.i_Out_ReadTextOptions_get_Colspecs
        to_return = _convert_from_pb_47(read_text_options_response.result, self._cache_manager.get_object)
        return to_return

    def get_target(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        read_text_options_request.i_In_ReadTextOptions_get_Target.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.get_Target
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        read_text_options_response = response.iReadTextOptions.i_Out_ReadTextOptions_get_Target
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(read_text_options_response.result)
        return to_return

    def set_target(self, value):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        NullValueConverterUtils.convert_to_pb_nullable_string(read_text_options_request.i_In_ReadTextOptions_set_Target.value, value)
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.set_Target
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    def get_detect_data_types(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        read_text_options_request.i_In_ReadTextOptions_get_DetectDataTypes.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.get_DetectDataTypes
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        read_text_options_response = response.iReadTextOptions.i_Out_ReadTextOptions_get_DetectDataTypes
        to_return = read_text_options_response.result
        return to_return

    def set_detect_data_types(self, value):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        read_text_options_request.i_In_ReadTextOptions_set_DetectDataTypes.value = value
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.set_DetectDataTypes
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    def get_allowed_targets(self):
        def _convert_from_pb_48(protobuf_object):
            """
            Converts the protobuf_object into python_object equivalent. />.
            :param protobuf_object:
            :param python_object:
            :return:
            """
            if protobuf_object.IsNullValue:
                return None
            return [NullValueConverterUtils.convert_from_pb_nullable_string(python_object) for python_object in protobuf_object.Value]


        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'ReadTextOptions' object from request and set parameters
        read_text_options_request = request.iReadTextOptions
        read_text_options_request.i_In_ReadTextOptions_get_AllowedTargets.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        while True:
            # Communicate with Coreclr
            received_bytes = self._background_process.communicate(message_request)

            # If we didn't receive any bytes, raise Error
            if received_bytes is None:
                raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

            message_response.ParseFromString(received_bytes)
            message_type = message_response.WhichOneof('ProseOutput')
            if message_type == 'responseFromDispatcher':
                break
            elif message_type != 'requestForFetcher':
                raise RuntimeError('C# should either send dispatcher output or fetcher request')
            fetcher_request = message_response.requestForFetcher
            from .prose_data_fetcher import ProseDataFetcher
            fetcher_object_to_invoke = self._cache_manager.get_fetcher_object(fetcher_request.referenceId)

            # Clear all fields to make sure we don't have stale message
            message_request.Clear()
            fetcher_response = message_request.responseFromFetcher
            ProseDataFetcher.invoke_fetcher_method(fetcher_request, fetcher_response, fetcher_object_to_invoke)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.get_AllowedTargets
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        read_text_options_response = response.iReadTextOptions.i_Out_ReadTextOptions_get_AllowedTargets
        to_return = _convert_from_pb_48(read_text_options_response.result)
        return to_return

    delimiter_overridden = property(get_delimiter_overridden, None, None, 'accessor for DelimiterOverridden')
    skip_overridden = property(get_skip_overridden, None, None, 'accessor for SkipOverridden')
    program_type = property(get_program_type, None, None, 'accessor for ProgramType')
    lines_to_analyze = property(get_lines_to_analyze, set_lines_to_analyze, None, 'accessor for LinesToAnalyze')
    encoding = property(get_encoding, None, None, 'accessor for Encoding')
    delimiter = property(get_delimiter, None, None, 'accessor for Delimiter')
    skip = property(get_skip, None, None, 'accessor for Skip')
    schema_filename = property(get_schema_filename, None, None, 'accessor for SchemaFilename')
    names = property(get_names, None, None, 'accessor for Names')
    colspecs = property(get_colspecs, None, None, 'accessor for Colspecs')
    target = property(get_target, set_target, None, 'accessor for Target')
    detect_data_types = property(get_detect_data_types, set_detect_data_types, None, 'accessor for DetectDataTypes')
    allowed_targets = property(get_allowed_targets, None, None, 'accessor for AllowedTargets')
    def __del__(self):

        # If we haven't initialized successfully, just return
        if not hasattr(self, 'referenceId'):
            return
        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId
        request.DeleteFromCache.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, just return
        if received_bytes is None:
            return

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by ReadTextOptions.__del__
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    __slots__ = ['_background_process', '_cache_manager', 'referenceId', '__weakref__']


class ReadTextOptions(ReadTextOptionsApi):
    def __init__(self, prepopulated_referenceId=None):
        background_process = BackgroundProcess(r'Microsoft.ProgramSynthesis.Python.CodeAccelerator.Internals.dll', '04/18/2020 05:15:37', process_terminator)
        assert background_process._process_state == _ProcessState.RUNNING
        super().__init__(background_process, prepopulated_referenceId)

    def __del__(self):
        super().__del__()

    __slots__ = []

    @classmethod
    def prepopulated_object_builder(cls, prepopulated_referenceId):
        """
        Method to construct ReadTextOptions object if equivalent C# object is already created
        """

        return ReadTextOptions(prepopulated_referenceId)
