# Copyright (c) Microsoft Corporation.  All rights reserved.
# This file is auto-generated. Do not make manual changes.

from .protobuf_objects import ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseDispatchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .protobuf_objects import ProseFetchApisMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2
from .background_process import BackgroundProcess, _ProcessState
from .cache_manager import CacheManager
from .protobuf_objects.background_process_terminate import process_terminator
from .null_value_converter_utils import NullValueConverterUtils
from . import column_info


class SingleColumnProfileResultApi(object):
    def __init__(self, background_process, prepopulated_referenceId=None):
        assert background_process is not None
        self._background_process = background_process
        self._cache_manager = CacheManager(id(background_process))

        # if object was already created in C#, just initialize the referenceId.
        if prepopulated_referenceId is not None:
            self.referenceId = prepopulated_referenceId
            self._cache_manager.add_object(self.referenceId, self)
            return
        # else if object is constructed in Python, then create an equivalent in C#.

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher


        # Extract 'SingleColumnProfileResult' object from request and set parameters
        single_column_profile_result_request = request.iSingleColumnProfileResult
        single_column_profile_result_request.i_In_SingleColumnProfileResult___init__.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by SingleColumnProfileResult..ctor
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)
        # Ensure we have a valid referenceId
        if response.referenceId is 0:
            raise ValueError('Failed to create SingleColumnProfileResult object.')
        self.referenceId = response.referenceId
        # Cache the object
        self._cache_manager.add_object(self.referenceId, self)

    def get_target_column(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'SingleColumnProfileResult' object from request and set parameters
        single_column_profile_result_request = request.iSingleColumnProfileResult
        single_column_profile_result_request.i_In_SingleColumnProfileResult_get_TargetColumn.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by SingleColumnProfileResult.get_TargetColumn
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        single_column_profile_result_response = response.iSingleColumnProfileResult.i_Out_SingleColumnProfileResult_get_TargetColumn
        to_return = NullValueConverterUtils.convert_from_pb_XplatPyNetCustomObject(single_column_profile_result_response.result, self._cache_manager.get_object, column_info.ColumnInfo.prepopulated_object_builder)
        return to_return

    def get_dominant_domain_type_name(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'SingleColumnProfileResult' object from request and set parameters
        single_column_profile_result_request = request.iSingleColumnProfileResult
        single_column_profile_result_request.i_In_SingleColumnProfileResult_get_DominantDomainTypeName.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by SingleColumnProfileResult.get_DominantDomainTypeName
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        single_column_profile_result_response = response.iSingleColumnProfileResult.i_Out_SingleColumnProfileResult_get_DominantDomainTypeName
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(single_column_profile_result_response.result)
        return to_return

    def get_dominant_domain_type_count(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'SingleColumnProfileResult' object from request and set parameters
        single_column_profile_result_request = request.iSingleColumnProfileResult
        single_column_profile_result_request.i_In_SingleColumnProfileResult_get_DominantDomainTypeCount.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by SingleColumnProfileResult.get_DominantDomainTypeCount
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        single_column_profile_result_response = response.iSingleColumnProfileResult.i_Out_SingleColumnProfileResult_get_DominantDomainTypeCount
        to_return = single_column_profile_result_response.result
        return to_return

    def get_null_string_count(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'SingleColumnProfileResult' object from request and set parameters
        single_column_profile_result_request = request.iSingleColumnProfileResult
        single_column_profile_result_request.i_In_SingleColumnProfileResult_get_NullStringCount.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by SingleColumnProfileResult.get_NullStringCount
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        single_column_profile_result_response = response.iSingleColumnProfileResult.i_Out_SingleColumnProfileResult_get_NullStringCount
        to_return = single_column_profile_result_response.result
        return to_return

    def get_empty_string_count(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'SingleColumnProfileResult' object from request and set parameters
        single_column_profile_result_request = request.iSingleColumnProfileResult
        single_column_profile_result_request.i_In_SingleColumnProfileResult_get_EmptyStringCount.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by SingleColumnProfileResult.get_EmptyStringCount
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        single_column_profile_result_response = response.iSingleColumnProfileResult.i_Out_SingleColumnProfileResult_get_EmptyStringCount
        to_return = single_column_profile_result_response.result
        return to_return

    def get_sample_count(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'SingleColumnProfileResult' object from request and set parameters
        single_column_profile_result_request = request.iSingleColumnProfileResult
        single_column_profile_result_request.i_In_SingleColumnProfileResult_get_SampleCount.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by SingleColumnProfileResult.get_SampleCount
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        single_column_profile_result_response = response.iSingleColumnProfileResult.i_Out_SingleColumnProfileResult_get_SampleCount
        to_return = single_column_profile_result_response.result
        return to_return

    def get_column_name(self):

        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId

        # Extract 'SingleColumnProfileResult' object from request and set parameters
        single_column_profile_result_request = request.iSingleColumnProfileResult
        single_column_profile_result_request.i_In_SingleColumnProfileResult_get_ColumnName.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()

        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, raise Error
        if received_bytes is None:
            raise RuntimeError('Internal error has occurred. Please retry the entire scenario.')

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by SingleColumnProfileResult.get_ColumnName
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

        # Process the result
        single_column_profile_result_response = response.iSingleColumnProfileResult.i_Out_SingleColumnProfileResult_get_ColumnName
        to_return = NullValueConverterUtils.convert_from_pb_nullable_string(single_column_profile_result_response.result)
        return to_return

    target_column = property(get_target_column, None, None, 'accessor for TargetColumn')
    dominant_domain_type_name = property(get_dominant_domain_type_name, None, None, 'accessor for DominantDomainTypeName')
    dominant_domain_type_count = property(get_dominant_domain_type_count, None, None, 'accessor for DominantDomainTypeCount')
    null_string_count = property(get_null_string_count, None, None, 'accessor for NullStringCount')
    empty_string_count = property(get_empty_string_count, None, None, 'accessor for EmptyStringCount')
    sample_count = property(get_sample_count, None, None, 'accessor for SampleCount')
    column_name = property(get_column_name, None, None, 'accessor for ColumnName')
    def __del__(self):

        # If we haven't initialized successfully, just return
        if not hasattr(self, 'referenceId'):
            return
        # Create a request object for dispatcher
        message_request = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.PythonToCSharp()
        request = message_request.requestForDispatcher

        request.referenceId = self.referenceId
        request.DeleteFromCache.SetInParent()
        message_response = ProseMicrosoftProgramSynthesisPythonCodeAcceleratorInternals_pb2.CSharpToPython()
        # Communicate with Coreclr
        received_bytes = self._background_process.communicate(message_request)

        # If we didn't receive any bytes, just return
        if received_bytes is None:
            return

        message_response.ParseFromString(received_bytes)
        response = message_response.responseFromDispatcher

        # Check if any exception was thrown by SingleColumnProfileResult.__del__
        if response.WhichOneof('ScenarioOutput') == 'Exception':
            raise RuntimeError(response.Exception.message)

    __slots__ = ['_background_process', '_cache_manager', 'referenceId', '__weakref__']


class SingleColumnProfileResult(SingleColumnProfileResultApi):
    def __init__(self, prepopulated_referenceId=None):
        background_process = BackgroundProcess(r'Microsoft.ProgramSynthesis.Python.CodeAccelerator.Internals.dll', '04/18/2020 05:15:37', process_terminator)
        assert background_process._process_state == _ProcessState.RUNNING
        super().__init__(background_process, prepopulated_referenceId)

    def __del__(self):
        super().__del__()

    __slots__ = []

    @classmethod
    def prepopulated_object_builder(cls, prepopulated_referenceId):
        """
        Method to construct SingleColumnProfileResult object if equivalent C# object is already created
        """

        return SingleColumnProfileResult(prepopulated_referenceId)
