# Copyright (c) Microsoft Corporation.  All rights reserved.

from abc import ABC, abstractmethod


class ResultImpl(ABC):
    @property
    @abstractmethod
    def _internal(self):
        """Get the C# internal object that is backing this object."""

    @property
    def _telemetry_testing_data(self):
        """Get the list of collected telemetry events. None, if not in telemetry testing mode."""
        return self._internal.get_telemetry_testing_data()
